#!/usr/bin/env python3
#Main

'''

What's up nerd! Welcome to Keg Punk! A poorly written piece of
software that helps your drunk ass keep track of what's in the cellar.
I got real tired real fast of not knowing (or, more likely,
not being able to remember) how many kegs we had in the cooler.
If a keg blew in the middle of a rush, we had to run all the way
to the back not knowing if the keg we needed was even in there.
Enter Keg Punk. We whipped up this badass little program so bartenders
and homebrewers are always tracking what's on tap, how many kegs are
left, and what you've already gone through.

We are beer lovers with a programming problem...so don't expect
much from the code. Keg Punk is a labor of love, not perfection.

'''


from Visuals import *
import os as os
import tkinter.font as tkfont
from tkinter.filedialog import askopenfilename
from tkinter import filedialog
from tkinter import messagebox
import requests, zipfile, io
import urllib
import shutil
from urllib.request import urlopen
from bs4 import BeautifulSoup
import subprocess

#Main Application
class MainApplication(tk.Frame):

    #Set up root window and intialize GUI
    def __init__(self, parent, *args, **kwargs):
        tk.Frame.__init__(self, parent, *args, **kwargs)

        # Get todays date
        try:
            self.Date = date.today()
        except:  # If unable to get date (not connected to Wifi) set as Date Unknown
            self.Date = "Date Unknown"

        #Record start up to History file
        RecordStart = "-------------------------------- START (" + str(self.Date) + ") --------------------------------"
        self.Record(RecordStart)

        #Overwrite current version file (pull info from Settings.py code file)
        with open('Version.csv', mode='w', newline='') as Version_file:  # opens file with 'w' for overwrite
            Version_writer = csv.writer(Version_file, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
            Version_writer.writerow([Program, Version, PublishDate, Platform, Year])

        #Confirm download page is a valid url (The code below will not work (currently) if the downloads page is password protected)
        try:
            url_Downloads = 'https://www.arithmech.com/downloads'
            html = urlopen(url_Downloads)

            try:
                reqs = requests.get(url_Downloads)  # Get into page
                soup = BeautifulSoup(reqs.text, 'html.parser')  # Get everything

                urls = []  # Create empty list to hold urls
                for link in soup.find_all('a'):  # Look through everything
                    urls.append(link.get('href'))  # Get links

                for url in urls:  # Loop through urls in list
                    if 'LatestVersion.csv' in url:  # If the url contains string 'LatestVersion.csv'
                        url_LatestVersionFile = url  # save url
                    elif 'Update.zip' in url:  # If the url contains string 'Update.zip'
                        url_UpdateZip = url  # save url
                    else:
                        pass

                file = urllib.request.urlopen(url_LatestVersionFile)  # open file

                for line in file:  # Loop through lines of file
                    LatestVersion = line.decode("utf-8")  # Get text from line

                LatestVersion = LatestVersion.split(',')
                LatestVersion = LatestVersion[1]

            except:

                LatestVersion = "Not Available"
                url_UpdateZip = "Not Available"
                RecordStart = "Unable to get Latest Version or Update folder url's. Not able to check for updates."
                self.Record(RecordStart)

        except:

            LatestVersion = "Not Available"
            url_UpdateZip = "Not Available"
            RecordStart = "Unable to get Latest Version or Update folder url's. Not able to check for updates."
            self.Record(RecordStart)

        self.CheckCriticals(LatestVersion, url_UpdateZip)  # Check that all critical directories and files exist, if not, create them. Performs update if needed.
        self.ConvertDos2Unix()

        #Configure root window
        root.title(Title) #Set title
        root.configure(bg=W) #Set bg color
        root.geometry(Size) #Set wxh size
        root.grid_columnconfigure(0, weight=1)  # Expand to fit whole screen if maximized
        root.grid_rowconfigure(0, weight=1)  # Expand to fit whole screen if maximized

        m.NoteBook(self)  # Build Notebook widget and screens
        m.GetOptions(self)  # Open Options file and get options

        #Platform/screen dependent
        if Platform == "Windows":
            root.iconbitmap(Favicon) #Set favicon
            root.resizable(False, False)  # Do not allow resizing root window
        elif Platform == "Pi":
            if self.Val_ScreenSize == '7" Touchscreen': #If option set to run on 7" Touchsceen
                root.wm_attributes('-fullscreen', 'true')  # Removes border and title bar from toplevel
            else: #If option set to run on Desktop/Laptop
                pass

        #Record Update status and display message to user if update completed
        if self.Update == 'True':

            try: #Try to finish up the last few steps

                # Make newly updated script executable
                path_Main = str(self.Dir_Parent) + '/Main.py'
                subprocess.call('chmod +x ' + str(path_Main), shell=True)

                RecordStart = "Update Successful!"
                self.Record(RecordStart)
                messagebox.showinfo("Keg Punk Updated", "Keg Punk successfully updated from v" + str(self.CurrentVersion) + " to v" + str(LatestVersion) +
                                    "!\nOptions and settings have been set to default.\n\nKeg Punk will close for changes to take effect.")

                RecordStart = "User clicks 'OK' to close Keg Punk. Update changes will take effect on restart."
                self.Record(RecordStart)

                self.QuitKegPunk(root) #Quit Keg Punk

            except:

                RecordStart = "Update failed to make new script executable."
                self.Record(RecordStart)

                messagebox.showinfo("Executable Failed", "The update failed to make the new script executable.\nGo to https://www.arithmech.com/contact for help.")
                sys.exit(1)

        elif self.Update == 'False':
            RecordStart = "No update done"
            self.Record(RecordStart)

        # Record start up to History file
        RecordStart = "Start Up Complete - ROCK ON!"
        self.Record(RecordStart)

    #Record information to History.csv
    def Record(self, Message):

        with open('History.csv', mode='a', newline='') as History_file:  # opens file with 'a' for append, does not overwrite anything already in it
            History_writer = csv.writer(History_file, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
            History_writer.writerow([Message])

    #Check that all critical directories and files exist, if not, create them
    def CheckCriticals(self, LatestVersion, url_UpdateFolder):

        try:

            '''
            
            Step 1 - Get parent directory
            Step 2 - Compare current version and latest version
            Step 3 - If current version is different than latest version, prompt user to update.
            Step 2 - Check for program directories (img, Inventory, Options, Styles). Create any missing directory.
            Step 3 - Check for files in Inventory directory. For existing files, check data structure and update as needed. Create any missing file.
            Step 4 - Check for files in Options directory. Create any missing file and populate with default option settings.
            Step 5 - Check for files in Styles directory. Create any missing file and populate with corresponding list.
            Step 6 - Check for icon files. If any are missing, give critical error.
            Step 7 - Check for any 'loose' files. These would be files that are not needed after an update to the software. If they are found, delete them.
            Step 8 - Update/Overwrite current version file.
            
            '''

            Trim = 85
            Issues = 0
            Resolved = 0

            #Parent Directory
            self.Dir_Parent = os.getcwd() #Get the directory that Main.py is currently in

            RecordCheckCritical = "Parent Directory: " + str(self.Dir_Parent)
            self.Record(RecordCheckCritical)

            #If LatestVersion and url_UpdateZip available, run GetUpdate
            if LatestVersion == "Not Available" or url_UpdateFolder == "Not Available": #Offline or error getting version and folder url's
                pass
            else:
                self.GetUpdate(LatestVersion, url_UpdateFolder) #Check if Keg Punk is up to date, prompt user to update if not. Download and move update files/folders to parent directory.

            #Directories
            List_MissingDirectories = []
            for dir in List_Directories:
                if path.exists(dir) == True:  # Check if dir has been created, if not create dir

                    RecordCheckCritical = "Check Directories - " + str(dir) + " directory exists.............................................."
                    RecordCheckCritical = RecordCheckCritical[:Trim] + str("(passed)")
                    self.Record(RecordCheckCritical)

                else:

                    RecordCheckCritical = "Check Directories - " + str(dir) + " directory missing.............................................."
                    RecordCheckCritical = RecordCheckCritical[:Trim] + str("(ISSUE)")
                    self.Record(RecordCheckCritical)
                    Issues = Issues + 1

                    MissingDirectory = path.join(dir) #Set path to missing directory
                    os.makedirs(MissingDirectory) #Create directory

                    RecordCheckCritical = "Check Directories - " + str(dir) + " directory created.............................................."
                    RecordCheckCritical = RecordCheckCritical[:Trim] + str("(resolved)")
                    self.Record(RecordCheckCritical)
                    Resolved = Resolved + 1

                    List_MissingDirectories.append(dir)

            #Inventory Files
            for file in List_InventoryDirFiles: #Loop through list of file names that are supposed to be in Inventory
                Path_File = os.path.join('Inventory', file)

                if path.exists(Path_File) == True:

                    RecordCheckCritical = "Check Inventory Files - " + str(file) + " file exists................................................"
                    RecordCheckCritical = RecordCheckCritical[:Trim] + str("(passed)")
                    self.Record(RecordCheckCritical)

                    #Check structure of Current Inventory data
                    if Path_File == Path_Log:

                        #Depending on the version, get the column header list
                        if self.CurrentVersion == '1.0' or self.CurrentVersion == '1.1':
                            LogHeaders = List_v1LogHeaders #Log headers specific to versions 1.0 and 1.1
                        else:
                            LogHeaders = List_LogHeaders

                        self.DFLog = pd.read_csv(Path_Log, names = LogHeaders)  # Create Dataframe from Log.csv
                        rows = len(self.DFLog) #Get the number of rows of data in the file

                        if rows == 0: #If there is no data, pass
                            pass
                        else: #If there is data

                            List_OldLogHeaders = []
                            for col in self.DFLog:  # Loop through column headers of old dataframe
                                List_OldLogHeaders.append(col)  # Add to list

                            #Get the difference between the two dataframe structures (different columns)
                            List_Difference = (list(list(set(List_LogHeaders)-set(List_OldLogHeaders)) + list(set(List_OldLogHeaders)-set(List_LogHeaders))))
                            Num_Difference = len(List_Difference)
                            if Num_Difference == 0: #There is no difference between old and new dataframe structure, pass
                                RecordCheckCritical = "Check Inventory Files - Log file structure is up to date....................................................."
                                RecordCheckCritical = RecordCheckCritical[:Trim] + str("(passed)")
                                self.Record(RecordCheckCritical)
                                pass
                            else: #There is a difference between the old and new dataframe structure, proceed with changes
                                RecordCheckCritical = "Check Inventory Files - Log file structure is out of date....................................................."
                                RecordCheckCritical = RecordCheckCritical[:Trim] + str("(ISSUE)")
                                self.Record(RecordCheckCritical)
                                Issues = Issues + 1

                                self.DFLog = self.DFLog.drop(List_Difference, axis = 1) #Drop columns
                                self.DFLog.to_csv(Path_Log, index=False, header=False)  # writes updated Dataframe back to csv

                                #Compare structures to confirm
                                Num_Columns = len(self.DFLog.columns) #Count number of columns now in dataframe
                                Num_TargetColumns = len(List_LogHeaders) #Count number of headers (columns) in the new Log file structure

                                if Num_Columns == Num_TargetColumns:
                                    RecordCheckCritical = "Check Inventory Files - Log file structure has been updated....................................................."
                                    RecordCheckCritical = RecordCheckCritical[:Trim] + str("(resolved)")
                                    self.Record(RecordCheckCritical)
                                    Resolved = Resolved + 1
                                else:
                                    RecordCheckCritical = "Check Inventory Files - Columns after update = " + str(Num_Columns) + ", Target columns = " + str(Num_TargetColumns)
                                    self.Record(RecordCheckCritical)
                                    RecordCheckCritical = "Check Inventory Files - Critical fail...Log file structure did not update correctly."
                                    self.Record(RecordCheckCritical)

                                    messagebox.showerror("Epic Fail!", "The Log file structure failed to update correctly.\nGo to https://www.arithmech.com/contact for help.")
                                    sys.exit(1)

                else:

                    RecordCheckCritical = "Check Inventory Files - " + str(file) + " missing....................................................."
                    RecordCheckCritical = RecordCheckCritical[:Trim] + str("(ISSUE)")
                    self.Record(RecordCheckCritical)
                    Issues = Issues + 1

                    InventoryDirFile = path.join('Inventory', file)  # Creates .csv file
                    with open(InventoryDirFile, mode='a', newline='') as Missing_file:  # opens file with 'a' for append, does not overwrite anything already in it
                        Missing_file_writer = csv.writer(Missing_file, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)

                    RecordCheckCritical = "Check Inventory Files - " + str(file) + " file created in Inventory directory...................................."
                    RecordCheckCritical = RecordCheckCritical[:Trim] + str("(resolved)")
                    self.Record(RecordCheckCritical)
                    Resolved = Resolved + 1

            #Options Files
            for file in List_OptionsDirFiles: #Loop through list of file names that are supposed to be in Options
                Path_File = os.path.join('Options', file)

                if path.exists(Path_File) == True:

                    RecordCheckCritical = "Check Options Files - " + str(file) + " file exists....................................................."
                    RecordCheckCritical = RecordCheckCritical[:Trim] + str("(passed)")
                    self.Record(RecordCheckCritical)

                else:

                    RecordCheckCritical = "Check Options Files - " + str(file) + " missing.........................................................."
                    RecordCheckCritical = RecordCheckCritical[:Trim] + str("(ISSUE)")
                    self.Record(RecordCheckCritical)
                    Issues = Issues + 1

                    OptionsDirFile = path.join('Options', file)  # Creates .csv file
                    with open(OptionsDirFile, mode='a', newline='') as Missing_file:  # opens file with 'a' for append, does not overwrite anything already in it
                        Missing_file_writer = csv.writer(Missing_file, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)

                    RecordCheckCritical = "Check Options Files - " + str(file) + " file created in Options directory......................................"
                    RecordCheckCritical = RecordCheckCritical[:Trim] + str("(resolved)")
                    self.Record(RecordCheckCritical)
                    Resolved = Resolved + 1

                    if file == "Options.csv": #Set Default options
                        with open(Path_Options, mode='a', newline='') as Options_file:  # opens file with 'a' for append, does not overwrite anything already in it
                            Options_writer = csv.writer(Options_file, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
                            Options_writer.writerow([Def_Taps, Def_Entry, Def_Units, Def_Theme, Def_Info, Def_Screen, Def_Styles, Def_TapSize])

                    elif file == "Tap List Options.csv": #Set Default Tap List options

                        with open(Path_TapListOptions, mode='a', newline='') as Options_file:  # opens file with 'a' for append, does not overwrite anything already in it
                            Options_writer = csv.writer(Options_file, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
                            Options_writer.writerow([Def_BeerFontSize, Def_StyleFontSize, Def_SizePriceFontSize, Def_PadX, Def_PadY,
                                                     Def_Name, Def_ListName, Def_TopTitle, Def_Columns, Def_BackgroundColor,
                                                     Def_TopBackgroundColor, Def_NameTextColor, Def_ListNameTextColor, Def_BeerBackgroundColor, Def_BeerTextColor, Def_StyleBackgroundColor
                                                     , Def_StyleTextColor, Def_SizePriceBackgroundColor, Def_SizePriceTextColor, Def_NameFontSize, Def_ListNameFontSize, Def_DisplayStyle
                                                     , Def_DisplayABV, Def_DisplayDescription, Def_DisplayWrap, Def_DescriptionFontSize, Def_DescriptionBackgroundColor, Def_DesriptionTextColor
                                                        , Def_DisplayPricing, Def_PresetTheme])

            #Styles Files
            for file in List_StylesDirFiles:  # Loop through list of file names that are supposed to be in Styles
                Path_File = os.path.join('Styles', file)

                if path.exists(Path_File) == True:

                    RecordCheckCritical = "Check Styles Files - " + str(file) + " file exists......................................................"
                    RecordCheckCritical = RecordCheckCritical[:Trim] + str("(passed)")
                    self.Record(RecordCheckCritical)

                else:

                    RecordCheckCritical = "Check Styles Files - " + str(file) + " missing..........................................................."
                    RecordCheckCritical = RecordCheckCritical[:Trim] + str("(ISSUE)")
                    self.Record(RecordCheckCritical)
                    Issues = Issues + 1

                    StylesDirFile = path.join('Styles', file)  # Creates .csv file
                    with open(StylesDirFile, mode='a', newline='') as Missing_file:  # opens file with 'a' for append, does not overwrite anything already in it
                        Missing_file_writer = csv.writer(Missing_file, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)

                    RecordCheckCritical = "Check Styles Files - " + str(file) + " file created in Styles directory......................................."
                    RecordCheckCritical = RecordCheckCritical[:Trim] + str("(resolved)")
                    self.Record(RecordCheckCritical)
                    Resolved = Resolved + 1

                    if file == "Custom Styles.csv":  #Set Custom Styles file
                        with open(Path_CustomStyles, mode='a', newline='') as Styles_file:  # opens file with 'a' for append, does not overwrite anything already in it
                            Styles_writer = csv.writer(Styles_file, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
                            Styles_writer.writerow(['ADD STYLE'])

                    if file == "Basic Beer Styles.csv":  #Set Basic Beer Styles file
                        with open(Path_BasicBeerStyles, mode='a', newline='') as Styles_file:  # opens file with 'a' for append, does not overwrite anything already in it
                            for Style in List_BasicBeerStyles:
                                Styles_writer = csv.writer(Styles_file, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
                                Styles_writer.writerow([Style])

                    if file == "BJCP Styles.csv":  #Set BJCP Styles file
                        with open(Path_BJCPStyles, mode='a', newline='') as Styles_file:  # opens file with 'a' for append, does not overwrite anything already in it
                            for Style in List_BJCPStyles:
                                Styles_writer = csv.writer(Styles_file, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
                                Styles_writer.writerow([Style])

            #Icon Files
            List_OtherFilesInDir = os.listdir(self.Dir_Parent)
            for file in List_OtherFiles:

                if file in List_OtherFilesInDir:  # Check if other file exists

                    RecordCheckCritical = "Check Other Files - " + str(file) + " file exists.............................................."
                    RecordCheckCritical = RecordCheckCritical[:Trim] + str("(passed)")
                    self.Record(RecordCheckCritical)

                else:

                    RecordCheckCritical = "Check Other Files - " + str(file) + " file missing.............................................."
                    RecordCheckCritical = RecordCheckCritical[:Trim] + str("(ISSUE)")
                    self.Record(RecordCheckCritical)
                    Issues = Issues + 1

                    messagebox.showerror("Epic Fail!", "The " + str(file) + " file is missing!\nGo to https://www.arithmech.com/contact for help.")
                    sys.exit(1)

            #Loose Files
            List_All = os.listdir(self.Dir_Parent) #Get list of all files and directories in parent directory
            List_Delete = ['Options.csv', 'Styles.csv'] #List of extra files to check for. If these are found, delete them.

            f = 0
            for filedir in List_All:
                if filedir in List_Delete:
                    RecordCheckCritical = "Check Loose Files - " + str(filedir) + " file is loose.............................................."
                    RecordCheckCritical = RecordCheckCritical[:Trim] + str("(ISSUE)")
                    self.Record(RecordCheckCritical)
                    Issues = Issues + 1

                    os.remove(filedir) #Delete loose file

                    RecordCheckCritical = "Check Loose Files - " + str(filedir) + " file removed.............................................."
                    RecordCheckCritical = RecordCheckCritical[:Trim] + str("(resolved)")
                    self.Record(RecordCheckCritical)
                    Resolved = Resolved + 1

                    f = f + 1

            if f == 0:
                RecordCheckCritical = "Check Loose Files - No loose files found......................................................."
                RecordCheckCritical = RecordCheckCritical[:Trim] + str("(passed)")
                self.Record(RecordCheckCritical)

            #Record issues resolved
            RecordCheckCritical = str(Resolved) + " out of " + str(Issues) + " issues resolved............................................................"
            if Resolved == Issues:
                RecordCheckCritical = RecordCheckCritical[:Trim] + str("(passed)")
            elif Resolved < Issues:
                RecordCheckCritical = RecordCheckCritical[:Trim] + str("(failed)")
            self.Record(RecordCheckCritical)

        except:

            ErrorHandling.ShowError(self, "Epic Fail!", "There was an issue checking for the data folders.")

    #Check if Keg Punk is up to date, prompt user to update if not. Download and move update files/folders to parent directory.
    def GetUpdate(self, LatestVersion, url_UpdateFolder):

        #Get Current Version. Try to open the Version.csv file.
        try:

            with open('Version.csv') as csvfile:  # if version file exists, get details from it
                readCSV = csv.reader(csvfile, delimiter=',')
                readCSV = list(readCSV)  # Create list from file data

                self.Program = readCSV[0][Dict_VersionHeaders['Program']]
                self.Version = readCSV[0][Dict_VersionHeaders['Version']]
                self.PublishDate = readCSV[0][Dict_VersionHeaders['Published On']]
                self.Platform = readCSV[0][Dict_VersionHeaders['Platform']]
                self.Year = readCSV[0][Dict_VersionHeaders['Year']]

                #This is the version saved
                CurrentVersionDetails = self.Program + " " + self.Version + ", Published on " + self.PublishDate + ", Platform: " + self.Platform + ', Year: ' + str(self.Year)
                RecordCheckCritical = "Current Version - " + CurrentVersionDetails
                self.Record(RecordCheckCritical)

                self.CurrentVersion = self.Version

        except:  # If Version.csv file does not exist

            self.CurrentVersion = '1.0'


        RecordCheckCritical = "Latest Version - " + str(LatestVersion)
        self.Record(RecordCheckCritical)

        #Keg Punk up to date
        if self.CurrentVersion == LatestVersion:  # if the current version is equal to latest version
            RecordCheckCritical = "The current version is the same as the latest version - Keg Punk is up to date"
            self.Record(RecordCheckCritical)

            self.Update = 'False'

        #Keg Punk update available
        else:  # If the current version is different than the latest version, prompt user to update

            RecordCheckCritical = "User prompted to update Keg Punk"
            self.Record(RecordCheckCritical)

            answer = messagebox.askquestion("Keg Punk Update", "There's an update available for Keg Punk.\nDo you want to update from v" + str(self.CurrentVersion) + " to v" + str(LatestVersion) + "?")
            if answer == 'yes':  # If user clicks 'Yes' to update

                RecordCheckCritical = "User elects to update Keg Punk from version " + str(self.CurrentVersion) + " to " + str(LatestVersion)
                self.Record(RecordCheckCritical)

                # Download and extract zip folder to parent directory
                try:

                    r = requests.get(url_UpdateFolder)
                    z = zipfile.ZipFile(io.BytesIO(r.content))
                    z.extractall(self.Dir_Parent)

                    List_AllDirectories = os.listdir(self.Dir_Parent)  # Create list of all contents in parent directory
                    for dir in List_AllDirectories:  # Look through all contents in parent directory
                        if dir == 'Update':  # If found update folder

                            # Look through Update folder to see if there are any folders in the update (for example - an img folder)
                            List_UpdateDirectories = [d for d in os.listdir(dir) if os.path.isdir(os.path.join(dir, d))]

                            Num_UpdateDirectories = len(List_UpdateDirectories)
                            if Num_UpdateDirectories == 0:
                                pass
                            else:
                                #Cut/Paste folders to parent directory
                                for sub_dir in List_UpdateDirectories:
                                    if sub_dir == '.idea':
                                        pass
                                    else:
                                        path_dir = os.path.join(self.Dir_Parent, 'Update', sub_dir)  # Get path to folder
                                        Destination = self.Dir_Parent + "/" + str(sub_dir)  # Create path of copied folder in parent directory
                                        destination = shutil.move(path_dir, Destination)  #Cut folder to destination

                            # Look through update folder and get list of all files
                            List_AllUpdateContents = os.listdir(dir)  # Create list of everything in update folder (folders and files)
                            List_UpdateFiles = []  # Create empty list to hold files

                            for content in List_AllUpdateContents:  # Loop through list of everything in update folder
                                if content in List_UpdateDirectories:  # If the content is in the list of update folder directories, it is a directory
                                    pass
                                else:
                                    List_UpdateFiles.append(content)  # If it's not a directory, it's a file, add to list

                            # Loop through list of files in update folder and copy to parent directory
                            for file in List_UpdateFiles:
                                path_file = os.path.join(self.Dir_Parent, 'Update', file)  # Get path to file
                                Destination = self.Dir_Parent + "/" + str(file)  # Create path of copied file in parent directory
                                destination = shutil.move(path_file, Destination)  #Cut file to destination

                            # Delete update folder
                            path_UpdateFolder = os.path.join(self.Dir_Parent, 'Update')
                            shutil.rmtree(path_UpdateFolder)

                    self.Update = 'True'

                    RecordCheckCritical = "Update successfully downloaded and moved to parent directory......................................."
                    RecordCheckCritical = RecordCheckCritical[:85] + str("(passed)")
                    self.Record(RecordCheckCritical)

                except:

                    self.Update = 'False'
                    RecordCheckCritical = "Update failed!!!"
                    self.Record(RecordCheckCritical)

                    messagebox.showerror('Epic Fail!', 'Keg Punk failed to update!\nGo to https://www.arithmech.com/contact for help.')

            else:

                RecordCheckCritical = "User declines to update Keg Punk"
                self.Record(RecordCheckCritical)

                self.Update = 'False'

    #Install dos2unix and use to convert line ending characters
    def ConvertDos2Unix(self):

        try:

            print("Check for dos2unix")
            subprocess.call('sudo apt install dos2unix', shell = True)
            print("dos2unix ready to go")
            path_Main = str(self.Dir_Parent) + '/Main.py'
            subprocess.call('dos2unix ' + str(path_Main), shell = True)
            print("Converted line ending characters with dos2unix")

        except:

            ErrorHandling.ShowError(self, "Epic Fail!", "There was an issue converting the code files with Dos2Unix.")

    #Build notebook (tabs for Taproom, Cellar, Options)
    def NoteBook(self):

        try:

            #Main Notebook widget
            self.Note_Main = ttk.Notebook(root, height=Height)
            #self.Note_Main.pack(side=tk.TOP, fill=tk.BOTH, expand=tk.TRUE)
            self.Note_Main.grid(row=0, column=0, sticky=tk.NSEW)
            #Individual Tab frames
            self.Frame_Taproom = ttk.Frame(self.Note_Main, relief=tk.RAISED) #Taproom
            self.Frame_Cellar = ttk.Frame(self.Note_Main, relief=tk.RAISED) #Cellar
            self.Frame_MainReports = ttk.Frame(self.Note_Main, relief=tk.RAISED) #Reports
            self.Frame_TapList = ttk.Frame(self.Note_Main, relief=tk.RAISED)  #Tap List
            self.Frame_UserOptions = ttk.Frame(self.Note_Main, relief=tk.RAISED) #Options
            #Add tab frames to notebook
            self.Note_Main.add(self.Frame_Taproom, text='TAPROOM') #Taproom
            self.Note_Main.add(self.Frame_Cellar, text='CELLAR') #Cellar
            self.Note_Main.add(self.Frame_MainReports, text='REPORTS') #Reports
            self.Note_Main.add(self.Frame_TapList, text='TAP LIST')  #Tap List
            self.Note_Main.add(self.Frame_UserOptions, text='OPTIONS') #Options

            #Link function to notebook to change tabs/screens
            self.Note_Main.bind("<<NotebookTabChanged>>", lambda event: m.Screen(self, self.Note_Main.tab(self.Note_Main.select(), "text")))

        except:

            ErrorHandling.ShowError(self, "Epic Fail!", "The main screen failed to load.")

    #Build foundation of screen for tab selected (Taproom, Cellar, Reports, Options)
    def Screen(self, Tab):

        try:

            #Taproom Screen
            if Tab == "TAPROOM":

                # Clear Screen
                for wid in self.Frame_Taproom.winfo_children():
                    wid.destroy()

                # Clear toplevels if up (except Tap List)
                for wid in root.winfo_children():
                    if wid.winfo_class() == "Toplevel":
                        if wid.winfo_name() == 'taplist':
                            pass
                        else:
                            wid.destroy()

                #TaproomStatus holds Taps and bottom menu (Left)
                self.Frame_TaproomStatus = tk.Frame(self.Frame_Taproom, bg=self.BGColor)
                self.Frame_TaproomStatus.pack(side=tk.LEFT, fill=tk.BOTH, expand=tk.TRUE)
                #TaproomInv holds On Tap and Cellar listboxes (Right)
                self.Frame_TaproomInv = tk.Frame(self.Frame_Taproom, bg = self.Color2)
                self.Frame_TaproomInv.pack(side=tk.LEFT, fill=tk.BOTH, expand=tk.FALSE)

                #Taps (Top) and Menu (Bottom) frames for Taproom
                self.Frame_Taps = tk.Frame(self.Frame_TaproomStatus, bg=self.BGColor)
                self.Frame_Taps.pack(side=tk.TOP, fill=tk.X, padx = 4)
                self.Frame_Menu = tk.Frame(self.Frame_TaproomStatus, bg=self.BGColor)
                self.Frame_Menu.pack(side=tk.BOTTOM, fill=tk.X, padx = 4)

                #Tap Status Frame (Holds taps)
                self.Frame_TapStatus = tk.Frame(self.Frame_Taps, bg=self.Color)
                self.Frame_TapStatus.pack(side=tk.TOP, fill=tk.X, expand=tk.TRUE, anchor=tk.W)

                #On Tap listbox frame (Top)
                self.Frame_OnTap = tk.Frame(self.Frame_TaproomInv, bg = self.Color2)
                self.Frame_OnTap.pack(side=tk.TOP, fill=tk.BOTH, expand = tk.TRUE)

                #Listbox labels
                self.Lbl_OnTap = tk.Label(self.Frame_OnTap, text="ON TAP", font = F4, fg = self.TextColor2, bg = self.Color2).pack(side=tk.TOP)

                #Call functions to build listboxes and taps
                tm.BuildOnTapListbox(self, self.Frame_OnTap) #Build On Tap listbox
                ts.BuildTaps(self, self.Val_NumTaps, self.Frame_Taps, root, self.Val_TapSize) #Build Taps (based on Number of Taps option)

                # Reset any recalled information
                CellarManager.Str_SizePrice = ""
                CellarManager.Description = ""

            #Cellar Screen
            elif Tab == "CELLAR":

                # Clear Screen
                for wid in self.Frame_Cellar.winfo_children():
                    wid.destroy()

                # Clear toplevels if up (except Tap List)
                for wid in root.winfo_children():
                    if wid.winfo_class() == "Toplevel":
                        if wid.winfo_name() == 'taplist':
                            pass
                        else:
                            wid.destroy()

                #CellarManager frame on top for entry widgets and menu
                self.Frame_CellarManager = tk.Frame(self.Frame_Cellar, bg=self.BGColor)
                self.Frame_CellarManager.grid(row=0, column=0, sticky=tk.NSEW)
                self.Frame_Cellar.grid_rowconfigure(0, weight=0)
                self.Frame_Cellar.grid_columnconfigure(0, weight=1)
                #CellarInv frame on bottom for Cellar listbox
                self.Frame_CellarInv = tk.Frame(self.Frame_Cellar, bg=self.BGColor)
                self.Frame_CellarInv.grid(row=1, column=0, sticky=tk.NSEW)
                self.Frame_Cellar.grid_rowconfigure(1, weight=1)
                self.Frame_Cellar.grid_columnconfigure(0, weight=1)

                #Top,Middle, Bottom Frames for Cellar Manager
                self.Frame_TopMenu = tk.Frame(self.Frame_CellarManager, bg = self.Color2)
                self.Frame_TopMenu.pack(side=tk.TOP, fill=tk.X, expand = tk.FALSE, anchor = tk.NW)
                self.Frame_Input = tk.Frame(self.Frame_CellarManager, bg = self.BGColor)
                self.Frame_Input.pack(side=tk.TOP, fill=tk.BOTH, expand = tk.TRUE, anchor = tk.NW)
                self.Frame_InputLeft = tk.Frame(self.Frame_Input, bg=self.BGColor)
                self.Frame_InputLeft.pack(side=tk.LEFT, anchor=tk.NW, padx = 2)
                self.Frame_InputMiddle = tk.Frame(self.Frame_Input, bg=self.BGColor)
                self.Frame_InputMiddle.pack(side=tk.LEFT, anchor=tk.NW, padx = 2)
                self.Frame_InputRight = tk.Frame(self.Frame_Input, bg=self.BGColor)
                self.Frame_InputRight.pack(side=tk.LEFT, anchor=tk.NE, padx = 2)
                self.Frame_BottomMenu = tk.Frame(self.Frame_CellarManager, bg = self.BGColor)
                self.Frame_BottomMenu.pack(side=tk.BOTTOM, anchor = tk.N, pady = 4)

                #"New Batch" label above entry widgets
                self.Lbl_NewBatch = tk.Label(self.Frame_TopMenu, text="NEW BATCH", fg=self.TextColor2, bg=self.Color2, font=F2).pack(side=tk.TOP, padx = 1, anchor = tk.N)

                # Top frame for holding listbox label
                self.Frame_Top = tk.Frame(self.Frame_CellarInv, bg = self.Color2)
                self.Frame_Top.pack(side=tk.TOP, fill=tk.X, expand=tk.FALSE, anchor=tk.NW)
                #Listbox frame for Cellar listbox
                self.Frame_Listbox = tk.Frame(self.Frame_CellarInv, bg = self.Color)
                self.Frame_Listbox.pack(side=tk.TOP, fill=tk.BOTH, expand=tk.TRUE, anchor=tk.NW)

                #Cellar label above listbox
                self.Lbl_Inventory = tk.Label(self.Frame_Top, text="CELLAR", fg = self.TextColor2, bg = self.Color2, font = F2).pack(side=tk.TOP)

                #Call functions to build listbox, update listbox, and build entry widgets
                cm.BuildCurrentInventoryListbox(self, self.Frame_Listbox, Tab) #Build Cellar listbox
                cm.UpdateCurrentInventoryListbox(self, Tab) #Populate Cellar listbox with CurrentInventory data
                cm.BuildEntryWidgets(self, self.Frame_InputLeft, self.Frame_InputMiddle, self.Frame_InputRight, self.Frame_BottomMenu) #Build entry widgets for entering new batch info

                root.bind_class("Entry", "<FocusIn>", remember_focus) #Used for Keyboard functionality

            #Options Screen
            elif Tab == "OPTIONS":

                WidgetWidth = 14 #Set width of entry/combo's

                #Clear frame
                for wid in self.Frame_UserOptions.winfo_children():
                    wid.destroy()

                # Clear toplevels if up (except Tap List)
                for wid in root.winfo_children():
                    if wid.winfo_class() == "Toplevel":
                        if wid.winfo_name() == 'taplist':
                            pass
                        else:
                            wid.destroy()

                #Options Frame
                self.Frame_Options = tk.Frame(self.Frame_UserOptions, bg = self.BGColor)
                self.Frame_Options.pack(side=tk.TOP, anchor=tk.W, fill = tk.BOTH, expand = tk.TRUE)
                self.Frame_OptionsLeft = tk.Frame(self.Frame_Options, bg=self.BGColor)
                self.Frame_OptionsLeft.pack(side=tk.LEFT, anchor=tk.W, fill=tk.BOTH, expand=tk.TRUE)
                self.Frame_OptionsRight = tk.Frame(self.Frame_Options, bg=SG)
                self.Frame_OptionsRight.pack(side=tk.RIGHT, anchor=tk.E, fill=tk.Y, expand=tk.TRUE)

                RightColor = SG
                InfoFont = F1

                #Info section
                VersionMsg = str(Program) + ", v" + str(Version) + ", " + str(Year) + "\nPlatform: " + str(Platform)
                self.Lbl_Version = tk.Label(self.Frame_OptionsRight, text=VersionMsg, font=InfoFont, bg=RightColor, fg=self.TextColor)
                self.Lbl_Version.pack(side = tk.TOP)

                CreatedByMsg = 'Created by:\nArithmech Analytics\nNew Orleans, LA'
                self.Lbl_CreatedBy = tk.Label(self.Frame_OptionsRight, text=CreatedByMsg, font=InfoFont, bg=RightColor, fg=self.TextColor)
                self.Lbl_CreatedBy.pack(side = tk.TOP)

                HelpMsg = "For help, go to\narithmech.com"
                self.Lbl_Help = tk.Label(self.Frame_OptionsRight, text=HelpMsg, font=InfoFont, bg=RightColor, fg=self.TextColor)
                self.Lbl_Help.pack(side = tk.TOP)

                #Button Formatting
                ImgWidth = 75
                ImgHeight = 75
                BtnHeight = 50
                if Platform == "Pi":
                    BtnWidth = 130
                    FontSize = F4
                elif Platform == "Windows":
                    BtnWidth = 110
                    FontSize = F4

                # Quit
                try:
                    photo = ImageTk.PhotoImage(Image.open(Path_ImgSmash).resize((ImgWidth, ImgHeight)))
                except:
                    photo = ImageTk.PhotoImage(Image.open('Ghost.png').resize((ImgWidth, ImgHeight)))
                self.Lbl_Image = tk.Label(self.Frame_OptionsRight, image=photo)
                self.Lbl_Image.image = photo
                self.Btn_Quit = tk.Button(self.Frame_OptionsRight, text="I QUIT!", width=BtnWidth, height=BtnHeight, bd=1, image=self.Lbl_Image.image, bg=self.Color, compound=tk.LEFT, font=FontSize, fg=self.TextColor2, anchor=tk.W, command=lambda: self.QuitKegPunk(root))
                self.Btn_Quit.pack(side=tk.BOTTOM, padx=4, pady=4)

                #View Files
                try:
                    photo = ImageTk.PhotoImage(Image.open(Path_ImgFiles).resize((ImgWidth, ImgHeight)))
                except:
                    photo = ImageTk.PhotoImage(Image.open('Ghost.png').resize((ImgWidth, ImgHeight)))
                self.Lbl_Image = tk.Label(self.Frame_OptionsRight, image=photo)
                self.Lbl_Image.image = photo
                self.Btn_ViewFiles = tk.Button(self.Frame_OptionsRight, text="VIEW\nFILES", width=BtnWidth, height=BtnHeight, bd=1, image=self.Lbl_Image.image,
                                               bg=self.Color, compound=tk.LEFT, font=FontSize, fg=self.TextColor2, anchor=tk.W, command=lambda: self.ViewFiles())
                self.Btn_ViewFiles.pack(side=tk.BOTTOM, padx=4, pady=4)

                #Check For Updates
                try:
                    photo = ImageTk.PhotoImage(Image.open(Path_ImgYay).resize((ImgWidth-20, ImgHeight-20)))
                except:
                    photo = ImageTk.PhotoImage(Image.open('Ghost.png').resize((ImgWidth, ImgHeight)))
                self.Lbl_Image = tk.Label(self.Frame_OptionsRight, image=photo)
                self.Lbl_Image.image = photo
                self.Btn_CheckForUpdates = tk.Button(self.Frame_OptionsRight, text="CHECK FOR\nUPDATES", width=BtnWidth, height=BtnHeight, bd=1, image=self.Lbl_Image.image,
                                               bg=self.Color, compound=tk.LEFT, font=F2, fg=self.TextColor2, anchor=tk.W, command=lambda: self.CheckForUpdates())
                self.Btn_CheckForUpdates.pack(side=tk.BOTTOM, padx=4, pady=4)

                # Reset
                try:
                    photo = ImageTk.PhotoImage(Image.open(Path_ImgSkull).resize((ImgWidth, ImgHeight)))
                except:
                    photo = ImageTk.PhotoImage(Image.open('Ghost.png').resize((ImgWidth, ImgHeight)))
                self.Lbl_Image = tk.Label(self.Frame_OptionsRight, image=photo)
                self.Lbl_Image.image = photo
                self.Btn_Reset = tk.Button(self.Frame_OptionsRight, text="RESET", width=BtnWidth, height=BtnHeight, bd=1, image=self.Lbl_Image.image, bg=self.Color, compound=tk.LEFT, font=FontSize, fg=self.TextColor2, anchor=tk.W)
                self.Btn_Reset.pack(side=tk.BOTTOM, padx=4, pady=4)
                self.Btn_Reset.config(state=tk.DISABLED, command=lambda: self.Reset())

                # Reset Check 2 (DEFCON 1)
                self.Var_Defcon1 = tk.StringVar(value=0)
                tk.Checkbutton(self.Frame_OptionsRight, text="DEFCON 1", fg=self.Color, onvalue=1, offvalue=0, variable=self.Var_Defcon1, selectcolor=self.BGColor, bg=RightColor).pack(side=tk.BOTTOM)
                self.Var_Defcon1.trace("w", lambda name, index, mode: self.CheckReset())

                # Reset Check 1 (DEFCON 2)
                self.Var_Defcon2 = tk.StringVar(value=0)
                tk.Checkbutton(self.Frame_OptionsRight, text="DEFCON 2", fg=self.Color, onvalue=1, offvalue=0, variable=self.Var_Defcon2, selectcolor=self.BGColor, bg=RightColor).pack(side=tk.BOTTOM)
                self.Var_Defcon2.trace("w", lambda name, index, mode: self.CheckReset())

                #General Frame
                self.Frame_GeneralOptions = tk.LabelFrame(self.Frame_OptionsLeft, text = "GENERAL", fg = self.TextColor, bg=self.BGColor)
                self.Frame_GeneralOptions.pack(side=tk.TOP, anchor=tk.W, fill=tk.X, expand=tk.FALSE, padx = 8)

                Val_pady = 8
                Val_padx = 8
                FontSize = F8

                # ScreenSize label and Combobox
                self.Lbl_ScreenSize = tk.Label(self.Frame_GeneralOptions, text="Screen\nSize", font=F2, bg=self.BGColor, fg=self.TextColor, justify = tk.RIGHT)
                self.Lbl_ScreenSize.grid(row=0, column=0, padx=Val_padx, pady=Val_pady, sticky=tk.E)
                self.Combo_ScreenSize = ttk.Combobox(self.Frame_GeneralOptions, values=ScreenSizes, width=WidgetWidth, font = FontSize, state="readonly")
                self.Combo_ScreenSize.option_add("*TCombobox*Listbox*Font", FontSize) #THIS LINE SETS THE FONT SIZE FOR ALL COMBOBOXES
                self.Combo_ScreenSize.grid(row=0, column=1, sticky=tk.W)
                self.Combo_ScreenSize.bind("<<ComboboxSelected>>", lambda event: m.SaveOptions(self))  # Value is saved when change made to widget value
                self.Combo_ScreenSize.set(value=self.Val_ScreenSize)  # Set combo to current option
                self.Lbl_ScreenSizeInfo = tk.Label(self.Frame_GeneralOptions, text='Are you running Keg Punk on a\ndesktop/laptop, or on a 7" Touchsceen?', font=F2, bg=self.BGColor, fg=self.Color, justify=tk.LEFT)
                self.Lbl_ScreenSizeInfo.grid(row=0, column=2, pady=Val_pady, padx=Val_padx, sticky=tk.W)
                if Platform == "Windows":
                    self.Combo_ScreenSize.config(state = tk.DISABLED)
                    self.Lbl_ScreenSize.config(state = tk.DISABLED)
                    self.Lbl_ScreenSizeInfo.config(state = tk.DISABLED)

                # Theme label and Combobox
                self.Lbl_Theme = tk.Label(self.Frame_GeneralOptions, text="Theme", font=F2, bg=self.BGColor, fg=self.TextColor, justify = tk.RIGHT)
                self.Lbl_Theme.grid(row=1, column=0, padx=Val_padx, pady=Val_pady, sticky=tk.E)
                self.Combo_Theme = ttk.Combobox(self.Frame_GeneralOptions, values=Themes, width=WidgetWidth, font = FontSize, state="readonly")
                self.Combo_Theme.grid(row=1, column=1, sticky=tk.W)
                self.Combo_Theme.bind("<<ComboboxSelected>>", lambda event: m.SaveOptions(self))  # Value is saved when change made to widget value
                self.Combo_Theme.set(value=self.Val_Theme)  # Set combo to current option
                self.Lbl_ThemeInfo = tk.Label(self.Frame_GeneralOptions, text="What kind of mood are\nyou in?", font=F2, bg=self.BGColor, fg=self.Color, justify=tk.LEFT)
                self.Lbl_ThemeInfo.grid(row=1, column=2, pady=Val_pady, padx=Val_padx, sticky=tk.W)

                # Entry label and Combobox
                self.Lbl_Entry = tk.Label(self.Frame_GeneralOptions, text="Entry\nType", font=F2, bg=self.BGColor, fg=self.TextColor, justify = tk.RIGHT)
                self.Lbl_Entry.grid(row=2, column=0, padx=Val_padx, pady=Val_pady, sticky=tk.E)
                self.Combo_Entry = ttk.Combobox(self.Frame_GeneralOptions, values=EntryTypes, width=WidgetWidth, font = FontSize, state="readonly")
                self.Combo_Entry.grid(row=2, column=1, sticky=tk.W)
                self.Combo_Entry.bind("<<ComboboxSelected>>", lambda event: m.SaveOptions(self))  # Value is saved when change made to widget value
                self.Combo_Entry.set(value=self.Val_EntryType)  # Set combo to current option
                self.Lbl_EntryInfo = tk.Label(self.Frame_GeneralOptions, text="Use a keyboard or\nmouse/touch to enter data?", font=F2, bg=self.BGColor, fg=self.Color, justify=tk.LEFT)
                self.Lbl_EntryInfo.grid(row=2, column=2, pady=Val_pady, padx=Val_padx, sticky=tk.W)

                # Taproom Frame
                self.Frame_TaproomOptions = tk.LabelFrame(self.Frame_OptionsLeft, text="TAPROOM", fg = self.TextColor, bg=self.BGColor)
                self.Frame_TaproomOptions.pack(side=tk.TOP, anchor=tk.W, fill=tk.X, expand=tk.FALSE, padx = 8)

                #Number of Taps label and Combobox
                self.Lbl_NumTaps = tk.Label(self.Frame_TaproomOptions, text="# Of\nTaps", font=F2, bg = self.BGColor, fg = self.TextColor, justify = tk.RIGHT)
                self.Lbl_NumTaps.grid(row = 0, column = 0, padx = Val_padx, pady=Val_pady, sticky = tk.E)
                self.Combo_NumTaps = ttk.Combobox(self.Frame_TaproomOptions, values=NumTaps, width=WidgetWidth, height = 7, font = FontSize, state="readonly")
                self.Combo_NumTaps.grid(row = 0, column = 1, pady = Val_pady, sticky = tk.W)
                self.Combo_NumTaps.bind("<<ComboboxSelected>>", lambda event: m.SaveOptions(self)) #Value is saved when change made to widget value
                self.Combo_NumTaps.set(value = self.Val_NumTaps) #Set combo to current option
                self.Lbl_NumTapsInfo = tk.Label(self.Frame_TaproomOptions, text="How many taps do you have\nbehind the bar?", font=F2, bg=self.BGColor, fg=self.Color, justify = tk.LEFT)
                self.Lbl_NumTapsInfo.grid(row=0, column=2, pady=Val_pady, padx = Val_padx, sticky=tk.W)

                # Display Info label and Combobox
                self.Lbl_DisplayInfo = tk.Label(self.Frame_TaproomOptions, text="Display\nInfo", font=F2, bg=self.BGColor, fg=self.TextColor, justify = tk.RIGHT)
                self.Lbl_DisplayInfo.grid(row=1, column=0, padx=Val_padx, pady=Val_pady, sticky=tk.E)
                self.Combo_DisplayInfo = ttk.Combobox(self.Frame_TaproomOptions, values=DisplayInfo, width=WidgetWidth, font = FontSize, state="readonly")
                self.Combo_DisplayInfo.grid(row=1, column=1, sticky=tk.W)
                self.Combo_DisplayInfo.bind("<<ComboboxSelected>>", lambda event: m.SaveOptions(self))  # Value is saved when change made to widget value
                self.Combo_DisplayInfo.set(value=self.Val_DisplayInfo)  # Set combo to current option
                self.Lbl_DisplayInfoInfo = tk.Label(self.Frame_TaproomOptions, text="What info do you want to\nsee below each tap?", font=F2, bg=self.BGColor, fg=self.Color, justify=tk.LEFT)
                self.Lbl_DisplayInfoInfo.grid(row=1, column=2, pady=Val_pady, padx=Val_padx, sticky=tk.W)

                # Tap Size Combo
                self.Lbl_TapSize = tk.Label(self.Frame_TaproomOptions, text="Tap Button\nSize ", fg=self.TextColor, bg=self.BGColor, font=F2, justify = tk.RIGHT)
                self.Lbl_TapSize.grid(row=2, column=0, padx=Val_padx, pady=Val_pady, sticky=tk.E)
                List_TapSizes = [60, 70, 80, 90, 100, 110, 120, 130, 140, 150, 160, 170, 180, 190, 200] #Values are in pixels
                self.Combo_TapSize = ttk.Combobox(self.Frame_TaproomOptions, values=List_TapSizes, width=WidgetWidth, font=FontSize, state="readonly")
                self.Combo_TapSize.grid(row=2, column=1, sticky=tk.W)
                self.Combo_TapSize.bind("<<ComboboxSelected>>", lambda event: m.SaveOptions(self))  # Value is saved when change made to widget value
                self.Combo_TapSize.set(value=self.Val_TapSize)  # Set combo to current option
                self.Lbl_TapSizeInfo = tk.Label(self.Frame_TaproomOptions, text="Adjust the tap buttons to fit your screen.", font=F2, bg=self.BGColor, fg=self.Color, justify=tk.LEFT)
                self.Lbl_TapSizeInfo.grid(row=2, column=2, pady=Val_pady, padx=Val_padx, sticky=tk.W)

                # Cellar Frame
                self.Frame_CellarOptions = tk.LabelFrame(self.Frame_OptionsLeft, text="CELLAR", fg = self.TextColor, bg=self.BGColor)
                self.Frame_CellarOptions.pack(side=tk.TOP, anchor=tk.W, fill=tk.X, expand=tk.FALSE, padx = 8)

                # Volume Unit label and Combobox
                self.Lbl_VolUnit = tk.Label(self.Frame_CellarOptions, text="Volume\nUnits", font=F2, bg=self.BGColor, fg=self.TextColor, justify = tk.RIGHT)
                self.Lbl_VolUnit.grid(row = 0, column=0, padx=Val_padx, pady=Val_pady, sticky = tk.E)
                self.Combo_VolUnit = ttk.Combobox(self.Frame_CellarOptions, values=VolumeUnits, width=WidgetWidth, font = FontSize, state="readonly")
                self.Combo_VolUnit.grid(row = 0, column=1, sticky = tk.W)
                self.Combo_VolUnit.bind("<<ComboboxSelected>>", lambda event: m.SaveOptions(self))  # Value is saved when change made to widget value
                self.Combo_VolUnit.set(value=self.Val_VolumeUnit) #Set combo to current option
                self.Lbl_VolUnitInfo = tk.Label(self.Frame_CellarOptions, text="Are your brite tanks measured in\nGallons or Barrels? (if you got 'em)", font=F2, bg=self.BGColor, fg=self.Color, justify = tk.LEFT)
                self.Lbl_VolUnitInfo.grid(row = 0, column=2, pady=Val_pady, padx = Val_padx, sticky=tk.W)

                # Styles label and Combobox
                self.Lbl_Styles = tk.Label(self.Frame_CellarOptions, text="Styles", font=F2, bg=self.BGColor, fg=self.TextColor, justify = tk.RIGHT)
                self.Lbl_Styles.grid(row = 1, column=0, padx=Val_padx, pady=Val_pady, sticky=tk.E)
                self.Combo_Styles = ttk.Combobox(self.Frame_CellarOptions, values=Styles, width=WidgetWidth, font = FontSize, state="readonly")
                self.Combo_Styles.grid(row = 1, column=1, sticky=tk.W)
                self.Combo_Styles.bind("<<ComboboxSelected>>", lambda event: m.SaveOptions(self))  # Value is saved when change made to widget value
                self.Combo_Styles.set(value=self.Val_Styles)  # Set combo to current option
                self.Lbl_StylesInfo = tk.Label(self.Frame_CellarOptions, text="Do you want detailed, basic,\n or custom styles to choose from?", font=F2, bg=self.BGColor, fg=self.Color, justify=tk.LEFT)
                self.Lbl_StylesInfo.grid(row = 1, column=2, pady=Val_pady, padx=Val_padx, sticky=tk.W)

                # Reset any recalled information
                CellarManager.Str_SizePrice = ""
                CellarManager.Description = ""

            #Reports Screen
            elif Tab == "REPORTS":

                #Clear frame
                for wid in self.Frame_MainReports.winfo_children():
                    wid.destroy()

                # Clear toplevels if up (except Tap List)
                for wid in root.winfo_children():
                    if wid.winfo_class() == "Toplevel":
                        if wid.winfo_name() == 'taplist':
                            pass
                        else:
                            wid.destroy()

                #Frame to hold report widgets
                self.Frame_Reports = tk.Frame(self.Frame_MainReports, bg = SI)
                self.Frame_Reports.pack(side=tk.TOP, anchor=tk.W, fill = tk.BOTH, expand = tk.TRUE)

                #Call functions to calculate statistics and build report
                Reports.CalculateStats(self)
                Reports.BuildReport(self, self.Frame_Reports)

                # Reset any recalled information
                CellarManager.Str_SizePrice = ""
                CellarManager.Description = ""

            #Tap List Screen
            elif Tab == "TAP LIST":

                m.GetTapListOptions(self) #Call function to look up saved options

                #Clear frame
                for wid in self.Frame_TapList.winfo_children():
                    wid.destroy()

                # Clear toplevels if up (except Tap List)
                for wid in root.winfo_children():
                    if wid.winfo_class() == "Toplevel":
                        if wid.winfo_name() == 'taplist':
                            pass
                        else:
                            wid.destroy()

                #Frame to hold Tap List widgets

                self.Frame_BottomTapList = tk.Frame(self.Frame_TapList, bg= SI)
                self.Frame_BottomTapList.pack(side=tk.TOP, anchor=tk.N, fill=tk.BOTH, expand=tk.TRUE)

                self.Frame_TopTapList = tk.Frame(self.Frame_TapList, bg=SI)
                self.Frame_TopTapList.pack(side=tk.TOP, anchor=tk.N, fill=tk.X, expand=tk.FALSE)

                self.Frame_BottomTapListLeft = tk.Frame(self.Frame_BottomTapList, bg=SI)
                self.Frame_BottomTapListLeft.pack(side=tk.LEFT, anchor=tk.NW, fill=tk.BOTH, expand=tk.FALSE)
                self.Frame_BottomTapListMiddle = tk.Frame(self.Frame_BottomTapList, bg=SI)
                self.Frame_BottomTapListMiddle.pack(side=tk.LEFT, anchor=tk.NW, fill=tk.BOTH, expand=tk.FALSE)
                self.Frame_BottomTapListRight = tk.Frame(self.Frame_BottomTapList, bg=SI)
                self.Frame_BottomTapListRight.pack(side=tk.LEFT, anchor=tk.NW, fill=tk.BOTH, expand=tk.FALSE)

                #Show/Hide
                self.Frame_ShowHide = tk.Frame(self.Frame_TopTapList, bg=self.BGColor)
                self.Frame_ShowHide.pack(side = tk.TOP, padx = 4, fill = tk.X)
                self.Frame_ShowHideTop = tk.Frame(self.Frame_ShowHide, bg=self.BGColor)
                self.Frame_ShowHideTop.pack(side = tk.TOP, fill = tk.X, expand = tk.TRUE)
                self.Frame_ShowHideTopLabel = tk.Frame(self.Frame_ShowHideTop, bg=self.Color)
                self.Frame_ShowHideTopLabel.pack(side=tk.TOP, fill=tk.X, expand=tk.TRUE)
                self.Frame_ShowHideTopButtons = tk.Frame(self.Frame_ShowHideTop, bg=self.BGColor)
                self.Frame_ShowHideTopButtons.pack(side=tk.TOP)

                #Show/Hide Header Label
                self.Lbl_Visibility = tk.Label(self.Frame_ShowHideTopLabel, text="VISIBILITY", font=F2, bg=self.Color, fg=self.TextColor2)
                self.Lbl_Visibility.pack()

                #Menu Buttons
                ImgWidth = 70
                ImgHeight = 70
                BtnWidth = 130
                BtnHeight = 50
                FontSize = F4

                #Show Button
                try:
                    photo = ImageTk.PhotoImage(Image.open(Path_ImgDrumset).resize((ImgWidth, ImgHeight)))
                except:
                    photo = ImageTk.PhotoImage(Image.open('Ghost.png').resize((ImgWidth, ImgHeight)))
                Lbl_Image = tk.Label(self.Frame_ShowHideTopButtons, image=photo)
                Lbl_Image.image = photo
                self.Btn_Show = tk.Button(self.Frame_ShowHideTopButtons, text="SHOW", width=BtnWidth, height=BtnHeight, bd=1, image=Lbl_Image.image, bg=self.Color2, compound=tk.LEFT, font=FontSize, fg=self.TextColor2, anchor=tk.W)
                self.Btn_Show.pack(side = tk.LEFT, padx = 4, pady = 4)
                self.Btn_Show.config(command = lambda: tl.CreateTapListScreen(self, root, 'False'))

                #Hide Button
                try:
                    photo = ImageTk.PhotoImage(Image.open(Path_ImgKick).resize((ImgWidth, ImgHeight)))
                except:
                    photo = ImageTk.PhotoImage(Image.open('Ghost.png').resize((ImgWidth, ImgHeight)))
                Lbl_Image = tk.Label(self.Frame_ShowHideTopButtons, image=photo)
                Lbl_Image.image = photo
                self.Btn_Hide = tk.Button(self.Frame_ShowHideTopButtons, text="HIDE", width=BtnWidth, height=BtnHeight, bd=1, image=Lbl_Image.image, bg=self.Color2, compound=tk.LEFT, font=FontSize, fg=self.TextColor2, anchor=tk.W)
                self.Btn_Hide.pack(side=tk.LEFT, padx=4, pady=4)
                self.Btn_Hide.config(command=lambda: tl.HideTapListScreen(self))

                #Full Screen Button
                try:
                    photo = ImageTk.PhotoImage(Image.open(Path_ImgExpand).resize((ImgWidth, ImgHeight)))
                except:
                    photo = ImageTk.PhotoImage(Image.open('Ghost.png').resize((ImgWidth, ImgHeight)))
                Lbl_Image = tk.Label(self.Frame_ShowHideTopButtons, image=photo)
                Lbl_Image.image = photo
                self.Btn_FullScreen = tk.Button(self.Frame_ShowHideTopButtons, text="FULL\nSCREEN", width=BtnWidth, height=BtnHeight, bd=1, image=Lbl_Image.image, bg=self.Color2, compound=tk.LEFT, font=FontSize, fg=self.TextColor2, anchor=tk.W)
                self.Btn_FullScreen.pack(side=tk.LEFT, padx=4, pady=4)
                self.Btn_FullScreen.config(command=lambda: tl.FullScreen(self))

                Frame_Left = self.Frame_BottomTapListLeft
                Frame_Middle = self.Frame_BottomTapListRight
                Frame_Right = self.Frame_BottomTapListMiddle
                SectionPadX = 4
                SectionPadY = 4
                LabelFont = F1

                #TOP TITLE
                if Platform == 'Windows':
                    WidgetWidth = 26
                elif Platform == 'Pi':
                    WidgetWidth = 16

                #Brewery Name
                self.Frame_TopTitle = tk.Frame(Frame_Left, bg=self.BGColor)
                self.Frame_TopTitle.pack(side = tk.TOP, fill = tk.X, padx = SectionPadX, pady = SectionPadY)
                self.Frame_TopTitleTop = tk.Frame(self.Frame_TopTitle, bg=self.Color)
                self.Frame_TopTitleTop.pack(side=tk.TOP, fill=tk.X)
                self.Frame_TopTitleBottom = tk.Frame(self.Frame_TopTitle, bg=self.BGColor)
                self.Frame_TopTitleBottom.pack(side=tk.BOTTOM, fill=tk.BOTH)

                #Brewery Name Header Label
                self.Lbl_TopTitle = tk.Label(self.Frame_TopTitleTop, text="TOP TITLE", font=F2, bg=self.Color, fg=self.TextColor2)
                self.Lbl_TopTitle.pack()

                # Create row header labels
                List_RowHeaders = ['Name', 'List Name', 'Top Title']
                r = 0
                for header in List_RowHeaders:
                    Lbl_RowHeader = tk.Label(self.Frame_TopTitleBottom, text=header, font=LabelFont, bg=self.BGColor, fg=self.TextColor)
                    Lbl_RowHeader.grid(row=r, column=0, padx=4, pady=4, sticky=tk.E)
                    r = r + 1

                self.In_BreweryName = tk.StringVar()
                self.Ent_BreweryName = tk.Entry(self.Frame_TopTitleBottom, textvariable=self.In_BreweryName, width=WidgetWidth + 1)
                self.Ent_BreweryName.grid(row=0, column=1, padx=4, pady=4, sticky=tk.W)
                self.Ent_BreweryName.insert(0, self.Val_Name)
                self.Ent_BreweryName.focus_set()
                self.In_BreweryName.trace("w", lambda name, index, mode: self.SaveTapListOptions()) #Call save function each time user makes ANY change to contents of entry box

                if self.Val_EntryType == "Touch":
                    self.Ent_BreweryName.bind("<Button-1>", lambda event: Keyboard.BuildKeyboard(self, root, "Cellar"))  # If on Touch, and user clicks in entry box, auto build keyboard

                self.Combo_ListName = ttk.Combobox(self.Frame_TopTitleBottom, values=ListNames, width=WidgetWidth, state="readonly")
                self.Combo_ListName.grid(row=1, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_ListName.set(value=self.Val_ListName)  # Set combo to current option
                self.Combo_ListName.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_ListName.option_add("*TCombobox*Listbox*Font", F8)  # THIS LINE SETS THE FONT SIZE FOR ALL COMBOBOXES
                self.Combo_ListName.bind('<Configure>', self.on_combo_configure(self.Combo_ListName))

                self.Combo_TopTitle = ttk.Combobox(self.Frame_TopTitleBottom, values=TopTitles, width=WidgetWidth, state="readonly")
                self.Combo_TopTitle.grid(row=2, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_TopTitle.set(value=self.Val_TopTitle)  # Set combo to current option
                self.Combo_TopTitle.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_TopTitle.bind('<Configure>', self.on_combo_configure(self.Combo_TopTitle))

                #Font
                self.Frame_Font = tk.Frame(Frame_Left, bg=self.Color)
                self.Frame_Font.pack(side = tk.TOP, fill = tk.X, padx = SectionPadX, pady = SectionPadY)
                self.Frame_FontTop = tk.Frame(self.Frame_Font, bg=self.Color)
                self.Frame_FontTop.pack(side=tk.TOP, fill=tk.X)
                self.Frame_FontBottom = tk.Frame(self.Frame_Font, bg=self.BGColor)
                self.Frame_FontBottom.pack(side=tk.BOTTOM, fill=tk.BOTH)

                #Font Header Label
                self.Lbl_Font = tk.Label(self.Frame_FontTop, text="FONT/SIZE", font=F2, bg=self.Color, fg=self.TextColor2)
                self.Lbl_Font.pack()

                #FONT
                if Platform == 'Windows':
                    WidgetWidth = 28
                elif Platform == 'Pi':
                    WidgetWidth = 15

                # Create row header labels
                List_RowHeaders = ['Name', 'List Name', 'Beer', 'Style', 'Price', 'Description']
                r = 0
                for header in List_RowHeaders:
                    Lbl_RowHeader = tk.Label(self.Frame_FontBottom, text=header, font=LabelFont, bg=self.BGColor, fg=self.TextColor)
                    Lbl_RowHeader.grid(row=r, column=0, padx=4, pady=4, sticky=tk.E)
                    r = r + 1

                #Name Font Size
                self.Combo_NameFontSize = ttk.Combobox(self.Frame_FontBottom, values=FontSizes, width=WidgetWidth, state="readonly")
                self.Combo_NameFontSize.grid(row=0, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_NameFontSize.set(value=self.Val_NameFontSize)  # Set combo to current option
                self.Combo_NameFontSize.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_NameFontSize.bind('<Configure>', self.on_combo_configure(self.Combo_NameFontSize))
                
                #ListName Font Size
                self.Combo_ListNameFontSize = ttk.Combobox(self.Frame_FontBottom, values=FontSizes, width=WidgetWidth, state="readonly")
                self.Combo_ListNameFontSize.grid(row=1, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_ListNameFontSize.set(value=self.Val_ListNameFontSize)  # Set combo to current option
                self.Combo_ListNameFontSize.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_ListNameFontSize.bind('<Configure>', self.on_combo_configure(self.Combo_ListNameFontSize))

                #Beer Font Size
                self.Combo_BeerFontSize = ttk.Combobox(self.Frame_FontBottom, values= FontSizes, width=WidgetWidth, state="readonly", height = 9)
                self.Combo_BeerFontSize.grid(row=2, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_BeerFontSize.set(value=self.Val_BeerFontSize)  # Set combo to current option
                self.Combo_BeerFontSize.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_BeerFontSize.bind('<Configure>', self.on_combo_configure(self.Combo_BeerFontSize))

                # Style Font Size
                self.Combo_StyleFontSize = ttk.Combobox(self.Frame_FontBottom, values=FontSizes, width=WidgetWidth, state="readonly", height = 8)
                self.Combo_StyleFontSize.grid(row=3, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_StyleFontSize.set(value=self.Val_StyleFontSize)  # Set combo to current option
                self.Combo_StyleFontSize.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_StyleFontSize.bind('<Configure>', self.on_combo_configure(self.Combo_StyleFontSize))

                # SizePrice Font Size
                self.Combo_SizePriceFontSize = ttk.Combobox(self.Frame_FontBottom, values=FontSizes, width=WidgetWidth, state="readonly", height = 7)
                self.Combo_SizePriceFontSize.grid(row=4, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_SizePriceFontSize.set(value=self.Val_SizePriceFontSize)  # Set combo to current option
                self.Combo_SizePriceFontSize.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_SizePriceFontSize.bind('<Configure>', self.on_combo_configure(self.Combo_SizePriceFontSize))

                # Description Font Size
                self.Combo_DescriptionFontSize = ttk.Combobox(self.Frame_FontBottom, values=FontSizes, width=WidgetWidth, state="readonly", height = 6)
                self.Combo_DescriptionFontSize.grid(row=5, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_DescriptionFontSize.set(value=self.Val_DescriptionFontSize)  # Set combo to current option
                self.Combo_DescriptionFontSize.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_DescriptionFontSize.bind('<Configure>', self.on_combo_configure(self.Combo_DescriptionFontSize))

                # SPACING
                if Platform == 'Windows':
                    WidgetWidth = 28
                elif Platform == 'Pi':
                    WidgetWidth = 6

                #Padding
                self.Frame_Padding = tk.Frame(Frame_Middle, bg=self.Color)
                self.Frame_Padding.pack(side = tk.TOP, fill = tk.X, padx = SectionPadX, pady = SectionPadY)
                self.Frame_PaddingTop = tk.Frame(self.Frame_Padding, bg=self.Color)
                self.Frame_PaddingTop.pack(side = tk.TOP, fill = tk.X)
                self.Frame_PaddingBottom = tk.Frame(self.Frame_Padding, bg=self.BGColor)
                self.Frame_PaddingBottom.pack(side=tk.BOTTOM, fill=tk.BOTH)

                # Padding Header Label
                self.Lbl_Padding = tk.Label(self.Frame_PaddingTop, text="SPACING", font=F2, bg=self.Color, fg=self.TextColor2)
                self.Lbl_Padding.pack()

                # PadX Font Size
                self.Lbl_PadX = tk.Label(self.Frame_PaddingBottom, text="Horizontal", font=LabelFont, bg=self.BGColor, fg=self.TextColor)
                self.Lbl_PadX.grid(row=1, column=0, padx=4, pady=4, sticky=tk.E)
                self.Combo_PadX = ttk.Combobox(self.Frame_PaddingBottom, values=PadX, width=WidgetWidth+2, state="readonly")
                self.Combo_PadX.grid(row=1, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_PadX.set(value=self.Val_PadX)  # Set combo to current option
                self.Combo_PadX.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value

                # PadY Font Size
                self.Lbl_PadY = tk.Label(self.Frame_PaddingBottom, text="Vertical", font=LabelFont, bg=self.BGColor, fg=self.TextColor)
                self.Lbl_PadY.grid(row=2, column=0, padx=4, pady=4, sticky=tk.E)
                self.Combo_PadY = ttk.Combobox(self.Frame_PaddingBottom, values=PadY, width=WidgetWidth+2, state="readonly")
                self.Combo_PadY.grid(row=2, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_PadY.set(value=self.Val_PadY)  # Set combo to current option
                self.Combo_PadY.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value

                #COLUMNS
                if Platform == 'Windows':
                    WidgetWidth = 10
                elif Platform == 'Pi':
                    WidgetWidth = 10

                #Columns
                self.Frame_Columns = tk.Frame(Frame_Middle, bg=self.BGColor)
                self.Frame_Columns.pack(side = tk.TOP, fill = tk.X, padx = SectionPadX, pady = SectionPadY, anchor = tk.W)
                self.Frame_ColumnsTop = tk.Frame(self.Frame_Columns, bg=self.Color)
                self.Frame_ColumnsTop.pack(side=tk.TOP, fill=tk.X)
                self.Frame_ColumnsBottom = tk.Frame(self.Frame_Columns, bg=self.BGColor)
                self.Frame_ColumnsBottom.pack(side=tk.BOTTOM, fill=tk.BOTH)

                #Columns Header Label
                self.Lbl_Columns = tk.Label(self.Frame_ColumnsTop, text="COLUMNS", font=F2, bg=self.Color, fg=self.TextColor2)
                self.Lbl_Columns.pack()

                # Columns Font Size
                self.Lbl_NumColumns = tk.Label(self.Frame_ColumnsBottom, text="# of Columns", font=LabelFont, bg=self.BGColor, fg=self.TextColor)
                self.Lbl_NumColumns.grid(row=0, column=0, padx=4, pady=4, sticky=tk.E)
                self.Combo_Columns = ttk.Combobox(self.Frame_ColumnsBottom, values=NumTaps, width=WidgetWidth-5, state="readonly")
                self.Combo_Columns.grid(row=0, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_Columns.set(value=self.Val_Columns)  # Set combo to current option
                self.Combo_Columns.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value

                #DISPLAY INFO
                if Platform == 'Windows':
                    WidgetWidth = 10
                elif Platform == 'Pi':
                    WidgetWidth = 15

                List_YesNo = ['Yes', 'No']

                #Display Info Frames
                self.Frame_DisplayInfo = tk.Frame(Frame_Middle, bg=self.BGColor)
                self.Frame_DisplayInfo.pack(side=tk.TOP, fill=tk.X, padx=SectionPadX, pady=SectionPadY, anchor=tk.W)
                self.Frame_DisplayInfoTop = tk.Frame(self.Frame_DisplayInfo, bg=self.Color)
                self.Frame_DisplayInfoTop.pack(side=tk.TOP, fill=tk.X)
                self.Frame_DisplayInfoBottom = tk.Frame(self.Frame_DisplayInfo, bg=self.BGColor)
                self.Frame_DisplayInfoBottom.pack(side=tk.BOTTOM, fill=tk.BOTH)

                #DisplayInfo Header Label
                self.Lbl_DisplayInfo = tk.Label(self.Frame_DisplayInfoTop, text="DISPLAY INFO", font=F2, bg=self.Color, fg=self.TextColor2)
                self.Lbl_DisplayInfo.pack()

                # Create row header labels
                List_RowHeaders = ['Style', 'ABV', 'Pricing', 'Description', 'Wrap Text\nAfter_?_Words']
                r = 0
                for header in List_RowHeaders:
                    Lbl_RowHeader = tk.Label(self.Frame_DisplayInfoBottom, text=header, font=LabelFont, bg=self.BGColor, fg=self.TextColor, justify = tk.RIGHT)
                    Lbl_RowHeader.grid(row=r, column=0, padx=4, pady=4, sticky=tk.E)
                    r = r + 1

                #Display Style
                self.Combo_DisplayStyle = ttk.Combobox(self.Frame_DisplayInfoBottom, values=List_YesNo, width=WidgetWidth-8, state="readonly")
                self.Combo_DisplayStyle.grid(row=0, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_DisplayStyle.set(value=self.Val_DisplayStyle)  # Set combo to current option
                self.Combo_DisplayStyle.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value

                #Display ABV
                self.Combo_DisplayABV = ttk.Combobox(self.Frame_DisplayInfoBottom, values=List_YesNo, width=WidgetWidth-8, state="readonly")
                self.Combo_DisplayABV.grid(row=1, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_DisplayABV.set(value=self.Val_DisplayABV)  # Set combo to current option
                self.Combo_DisplayABV.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value

                #Display Pricing
                self.Combo_DisplayPricing = ttk.Combobox(self.Frame_DisplayInfoBottom, values=List_YesNo, width=WidgetWidth-8, state="readonly")
                self.Combo_DisplayPricing.grid(row=2, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_DisplayPricing.set(value=self.Val_DisplayPricing)  # Set combo to current option
                self.Combo_DisplayPricing.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value

                #Display Description
                self.Combo_DisplayDescription = ttk.Combobox(self.Frame_DisplayInfoBottom, values=List_YesNo, width=WidgetWidth-8, height = 7, state="readonly")
                self.Combo_DisplayDescription.grid(row=3, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_DisplayDescription.set(value=self.Val_DisplayDescription)  # Set combo to current option
                self.Combo_DisplayDescription.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value

                #Wrap Description
                WrapAfter = list(range(1, 20))
                self.Combo_WrapDescription = ttk.Combobox(self.Frame_DisplayInfoBottom, values=WrapAfter, width=WidgetWidth-8, height = 6, state="readonly")
                self.Combo_WrapDescription.grid(row=4, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_WrapDescription.set(value=self.Val_DisplayWrap)  # Set combo to current option
                self.Combo_WrapDescription.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value

                # TOP TITLE
                if Platform == 'Windows':
                    WidgetWidth = 18
                elif Platform == 'Pi':
                    WidgetWidth = 13

                #Colors
                self.Frame_Colors = tk.Frame(Frame_Right, bg=self.BGColor)
                self.Frame_Colors.pack(side = tk.TOP, fill = tk.X, padx = SectionPadX, pady = SectionPadY)
                self.Frame_ColorsTop = tk.Frame(self.Frame_Colors, bg=self.Color)
                self.Frame_ColorsTop.pack(side=tk.TOP, fill=tk.X)
                self.Frame_ColorsBottom = tk.Frame(self.Frame_Colors, bg=self.BGColor)
                self.Frame_ColorsBottom.pack(side=tk.BOTTOM, fill=tk.BOTH)

                # Colors Header Label
                self.Lbl_Colors = tk.Label(self.Frame_ColorsTop, text="COLORS", font=F2, bg=self.Color, fg=self.TextColor2)
                self.Lbl_Colors.pack()

                #Preset Themes
                Lbl_PresetThemes = tk.Label(self.Frame_ColorsBottom, text='Presets', font=LabelFont, bg=self.BGColor, fg=self.TextColor)
                Lbl_PresetThemes.grid(row=0, column=0, padx=4, pady=4, sticky=tk.E)
                self.Combo_PresetThemes = ttk.Combobox(self.Frame_ColorsBottom, values=List_PresetThemes, width=WidgetWidth, state="readonly")
                self.Combo_PresetThemes.grid(row=0, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_PresetThemes.set(value=self.Val_PresetTheme)  # Set combo to current option
                self.Combo_PresetThemes.bind("<<ComboboxSelected>>", lambda event: m.PresetTheme(self, self.Combo_PresetThemes.get()))  # Value is saved when change made to widget value
                self.Combo_PresetThemes.bind('<Configure>', self.on_combo_configure(self.Combo_PresetThemes))

                #Column Headers
                self.Lbl_BackGroundColumn = tk.Label(self.Frame_ColorsBottom, text="BACKGROUND", font=F2, bg=self.BGColor, fg=self.TextColor)
                self.Lbl_BackGroundColumn.grid(row=1, column=1, padx=4, pady=4, sticky=tk.N)
                self.Lbl_TextColumn = tk.Label(self.Frame_ColorsBottom, text="TEXT", font=F2, bg=self.BGColor, fg=self.TextColor)
                self.Lbl_TextColumn.grid(row=1, column=2, padx=4, pady=4, sticky=tk.N)

                #Create row header labels
                List_RowHeaders = ['Background', 'Top', 'Name', 'List Name', 'Beer', 'Style', 'Price', 'Description']
                r = 2
                for header in List_RowHeaders:
                    Lbl_RowHeader = tk.Label(self.Frame_ColorsBottom, text=header, font=LabelFont, bg=self.BGColor, fg=self.TextColor)
                    Lbl_RowHeader.grid(row=r, column=0, padx=4, pady=4, sticky=tk.E)
                    r = r + 1

                #Create list from keys of Dict_Colors to populate combo boxes
                List_Colors = []
                for key in Dict_Colors.keys():
                    List_Colors.append(key)

                #Background background color
                self.Combo_BackgroundBG = ttk.Combobox(self.Frame_ColorsBottom, values=List_Colors, width=WidgetWidth, state="readonly")
                self.Combo_BackgroundBG.grid(row=2, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_BackgroundBG.set(value=self.Val_BackgroundColor)  # Set combo to current option
                self.Combo_BackgroundBG.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_BackgroundBG.bind('<Configure>', self.on_combo_configure(self.Combo_BackgroundBG))

                #Top Background color
                self.Combo_TopBG = ttk.Combobox(self.Frame_ColorsBottom, values=List_Colors, width=WidgetWidth, state="readonly")
                self.Combo_TopBG.grid(row=3, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_TopBG.set(value=self.Val_TopBackgroundColor)  # Set combo to current option
                self.Combo_TopBG.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_TopBG.bind('<Configure>', self.on_combo_configure(self.Combo_TopBG))

                #Name text color
                self.Combo_NameText = ttk.Combobox(self.Frame_ColorsBottom, values=List_Colors, width=WidgetWidth, state="readonly")
                self.Combo_NameText.grid(row=4, column=2, padx=4, pady=4, sticky=tk.W)
                self.Combo_NameText.set(value=self.Val_NameTextColor)  # Set combo to current option
                self.Combo_NameText.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_NameText.bind('<Configure>', self.on_combo_configure(self.Combo_NameText))

                #List Name text color
                self.Combo_ListNameText = ttk.Combobox(self.Frame_ColorsBottom, values=List_Colors, width=WidgetWidth, state="readonly")
                self.Combo_ListNameText.grid(row=5, column=2, padx=4, pady=4, sticky=tk.W)
                self.Combo_ListNameText.set(value=self.Val_ListNameTextColor)  # Set combo to current option
                self.Combo_ListNameText.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_ListNameText.bind('<Configure>', self.on_combo_configure(self.Combo_ListNameText))

                #Beer Background color
                self.Combo_BeerBG = ttk.Combobox(self.Frame_ColorsBottom, values=List_Colors, width=WidgetWidth, state="readonly")
                self.Combo_BeerBG.grid(row=6, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_BeerBG.set(value=self.Val_BeerBackgroundColor)  # Set combo to current option
                self.Combo_BeerBG.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_BeerBG.bind('<Configure>', self.on_combo_configure(self.Combo_BeerBG))

                #Beer Text color
                self.Combo_BeerText = ttk.Combobox(self.Frame_ColorsBottom, values=List_Colors, width=WidgetWidth, state="readonly")
                self.Combo_BeerText.grid(row=6, column=2, padx=4, pady=4, sticky=tk.W)
                self.Combo_BeerText.set(value=self.Val_BeerTextColor)  # Set combo to current option
                self.Combo_BeerText.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_BeerText.bind('<Configure>', self.on_combo_configure(self.Combo_BeerText))

                #Style Background color
                self.Combo_StyleBG = ttk.Combobox(self.Frame_ColorsBottom, values=List_Colors, width=WidgetWidth, height = 9, state="readonly")
                self.Combo_StyleBG.grid(row=7, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_StyleBG.set(value=self.Val_StyleBackgroundColor)  # Set combo to current option
                self.Combo_StyleBG.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_StyleBG.bind('<Configure>', self.on_combo_configure(self.Combo_StyleBG))

                #Style Text color
                self.Combo_StyleText = ttk.Combobox(self.Frame_ColorsBottom, values=List_Colors, width=WidgetWidth, height = 9, state="readonly")
                self.Combo_StyleText.grid(row=7, column=2, padx=4, pady=4, sticky=tk.W)
                self.Combo_StyleText.set(value=self.Val_StyleTextColor)  # Set combo to current option
                self.Combo_StyleText.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_StyleText.bind('<Configure>', self.on_combo_configure(self.Combo_StyleText))

                #SizePrice Background color
                self.Combo_SizePriceBG = ttk.Combobox(self.Frame_ColorsBottom, values=List_Colors, width=WidgetWidth, height = 8, state="readonly")
                self.Combo_SizePriceBG.grid(row=8, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_SizePriceBG.set(value=self.Val_SizePriceBackgroundColor)  # Set combo to current option
                self.Combo_SizePriceBG.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_SizePriceBG.bind('<Configure>', self.on_combo_configure(self.Combo_SizePriceBG))

                #SizePrice Text color
                self.Combo_SizePriceText = ttk.Combobox(self.Frame_ColorsBottom, values=List_Colors, width=WidgetWidth, height = 8, state="readonly")
                self.Combo_SizePriceText.grid(row=8, column=2, padx=4, pady=4, sticky=tk.W)
                self.Combo_SizePriceText.set(value=self.Val_SizePriceTextColor)  # Set combo to current option
                self.Combo_SizePriceText.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_SizePriceText.bind('<Configure>', self.on_combo_configure(self.Combo_SizePriceText))

                # Description Background color
                self.Combo_DescriptionBG = ttk.Combobox(self.Frame_ColorsBottom, values=List_Colors, width=WidgetWidth, height = 7, state="readonly")
                self.Combo_DescriptionBG.grid(row=9, column=1, padx=4, pady=4, sticky=tk.W)
                self.Combo_DescriptionBG.set(value=self.Val_DescriptionBackgroundColor)  # Set combo to current option
                self.Combo_DescriptionBG.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_DescriptionBG.bind('<Configure>', self.on_combo_configure(self.Combo_DescriptionBG))

                # Description Text color
                self.Combo_DescriptionText = ttk.Combobox(self.Frame_ColorsBottom, values=List_Colors, width=WidgetWidth, height = 7, state="readonly")
                self.Combo_DescriptionText.grid(row=9, column=2, padx=4, pady=4, sticky=tk.W)
                self.Combo_DescriptionText.set(value=self.Val_DescriptionTextColor)  # Set combo to current option
                self.Combo_DescriptionText.bind("<<ComboboxSelected>>", lambda event: m.SaveTapListOptions(self))  # Value is saved when change made to widget value
                self.Combo_DescriptionText.bind('<Configure>', self.on_combo_configure(self.Combo_DescriptionText))

                # Reset any recalled information
                CellarManager.Str_SizePrice = ""
                CellarManager.Description = ""

        except:

            ErrorHandling.ShowError(self, "Epic Fail!", "There was an issue loading the " + str(Tab) + " tab.")

    #Save options to Options.csv
    def SaveOptions(self):

        try:

            CurrentScreenSize = self.Val_ScreenSize

            #If user changed the number of taps, check if the new number is allowed given the current situation
            NumTaps = int(self.Val_NumTaps) #How many taps are there currently?

            DFOnTap = pd.read_csv(Path_OnTap, names=List_OnTapHeaders) #Create DF from OnTap.csv
            NumOnTap = int(len(DFOnTap)) #How many taps are currently occupied?

            Opt_NewNumTaps = int(self.Combo_NumTaps.get()) #What did the user select as the new number of taps?

            #Check if user can change the number of taps given the number currently on tap
            if Opt_NewNumTaps >= NumTaps: #If the new number of taps is greater than or equal to the current number, proceed (Ex. If there are currently 3 and user selects 5)
                Opt_NumTaps = Opt_NewNumTaps
            else: #If the new number of taps is less than the current number, check conditions
                if NumOnTap > 0: #If there are any beers currently on tap
                    self.Combo_NumTaps.set(value = NumTaps) #Set value of "# of Taps" combobox back to current number
                    ErrorHandling.ShowWarning(self, "Ugh, Rules!", "Can't decrease the # of Taps if anything is currently on tap!")
                    return #End function
                else: #If there are NO beers currently on tap, proceed
                    Opt_NumTaps = Opt_NewNumTaps

            # Get the values from other option comboboxes
            Opt_EntryType = self.Combo_Entry.get()
            Opt_VolumeUnit = self.Combo_VolUnit.get()
            Opt_Theme = self.Combo_Theme.get()
            Opt_DisplayInfo = self.Combo_DisplayInfo.get()
            Opt_ScreenSize = self.Combo_ScreenSize.get()
            Opt_Styles = self.Combo_Styles.get()
            Opt_TapSize = self.Combo_TapSize.get()

            #Save options to Options.csv
            with open(Path_Options, mode="w+", newline='') as Options_file:
                Options_file_writer = csv.writer(Options_file, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
                Options_file_writer.writerow([Opt_NumTaps, Opt_EntryType, Opt_VolumeUnit, Opt_Theme, Opt_DisplayInfo, Opt_ScreenSize, Opt_Styles, Opt_TapSize])

        except:

            ErrorHandling.ShowError(self, "Epic Fail!", "There was an issue saving your options.")

        self.GetOptions() #Get newly saved options
        self.Screen('OPTIONS') #Rebuild Options screen to update any option changes

        #If user is on Pi platform and switches screen size, need to restart for changes to take effect
        if Platform == "Pi":
            if Opt_ScreenSize == CurrentScreenSize:
                pass #If no change to screen size option, do nothing
            else:
                ErrorHandling.ShowInfo(self, "Reset", "Quit Keg Punk to reset the screen size.") #If user switches screen size, show message to restart
        else:
            pass

    # Save Tap List options to Tap List Options.csv
    def SaveTapListOptions(self):

        try:

            # Get the values from Tap List option comboboxes
            Opt_BeerFontSize = self.Combo_BeerFontSize.get()
            Opt_StyleFontSize = self.Combo_StyleFontSize.get()
            Opt_SizePriceFontSize = self.Combo_SizePriceFontSize.get()
            Opt_PadX = self.Combo_PadX.get()
            Opt_PadY = self.Combo_PadY.get()
            Opt_Name = self.Ent_BreweryName.get()
            Opt_ListName = self.Combo_ListName.get()
            Opt_TopList = self.Combo_TopTitle.get()
            Opt_Columns = self.Combo_Columns.get()
            Opt_BackgroundColor = self.Combo_BackgroundBG.get()
            Opt_TopBackgroundColor = self.Combo_TopBG.get()
            Opt_NameTextColor = self.Combo_NameText.get()
            Opt_ListNameTextColor = self.Combo_ListNameText.get()
            Opt_BeerBackgroundColor = self.Combo_BeerBG.get()
            Opt_BeerTextColor = self.Combo_BeerText.get()
            Opt_StyleBackgroundColor = self.Combo_StyleBG.get()
            Opt_StyleTextColor = self.Combo_StyleText.get()
            Opt_SizePriceBackgroundColor = self.Combo_SizePriceBG.get()
            Opt_SizePriceTextColor = self.Combo_SizePriceText.get()
            Opt_NameFontSize = self.Combo_NameFontSize.get()
            Opt_ListNameFontSize = self.Combo_ListNameFontSize.get()
            Opt_DisplayStyle = self.Combo_DisplayStyle.get()
            Opt_DisplayABV = self.Combo_DisplayABV.get()
            Opt_DisplayDescription = self.Combo_DisplayDescription.get()
            Opt_DisplayWrap = self.Combo_WrapDescription.get()
            Opt_DescriptionFontSize = self.Combo_DescriptionFontSize.get()
            Opt_DescriptionBackgroundColor = self.Combo_DescriptionBG.get()
            Opt_DescriptionTextColor = self.Combo_DescriptionText.get()
            Opt_DisplayPricing = self.Combo_DisplayPricing.get()
            Opt_PresetTheme = self.Combo_PresetThemes.get()

            # Save options to Options.csv
            with open(Path_TapListOptions, mode="w+", newline='') as TapListOptions_file:
                TapListOptions_file_writer = csv.writer(TapListOptions_file, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
                TapListOptions_file_writer.writerow([Opt_BeerFontSize, Opt_StyleFontSize, Opt_SizePriceFontSize, Opt_PadX, Opt_PadY, Opt_Name,
                                                     Opt_ListName, Opt_TopList, Opt_Columns, Opt_BackgroundColor, Opt_TopBackgroundColor,
                                                     Opt_NameTextColor, Opt_ListNameTextColor, Opt_BeerBackgroundColor, Opt_BeerTextColor,
                                                     Opt_StyleBackgroundColor, Opt_StyleTextColor, Opt_SizePriceBackgroundColor, Opt_SizePriceTextColor,
                                                     Opt_NameFontSize, Opt_ListNameFontSize, Opt_DisplayStyle, Opt_DisplayABV, Opt_DisplayDescription,
                                                     Opt_DisplayWrap, Opt_DescriptionFontSize, Opt_DescriptionBackgroundColor, Opt_DescriptionTextColor,
                                                     Opt_DisplayPricing, Opt_PresetTheme])

            TapList.CreateTapListScreen(self, root, 'True')

        except:

            ErrorHandling.ShowError(self, "Epic Fail!", "There was an issue saving your Tap List options.")

    #Open Options.csv and get options
    def GetOptions(self):

        try:

            #Open Options file and read row into a list
            with open(Path_Options) as csvfile:
                readCSV = csv.reader(csvfile, delimiter=',')
                readCSV = list(readCSV) #Create list from file data
                rows = len(readCSV) #Get number of items in list

                if rows == 0: #If there is nothing in the list, this implies options have not been set
                    self.Val_NumTaps = 0
                else: #If there are items in Options.csv, options have been set before
                    #Use dictionaries to look up column index of option
                    #readCSV[row index][column index]
                    self.Val_NumTaps = readCSV[0][Dict_OptionsColumn['Number of Taps']]
                    self.Val_EntryType = readCSV[0][Dict_OptionsColumn['Entry Type']]
                    self.Val_VolumeUnit = readCSV[0][Dict_OptionsColumn['Volume Unit']]
                    self.Val_Theme = readCSV[0][Dict_OptionsColumn['Theme']]
                    self.Val_DisplayInfo = readCSV[0][Dict_OptionsColumn['Display Info']]
                    self.Val_ScreenSize = readCSV[0][Dict_OptionsColumn['Screen Size']]
                    self.Val_Styles = readCSV[0][Dict_OptionsColumn['Styles']]
                    self.Val_TapSize = readCSV[0][Dict_OptionsColumn['Tap Size']]

            # Skate Park - Concrete and Traffic Cones
            if self.Val_Theme == "Skate Park":
                self.BGColor = GM #Gun Metal
                self.Color = O  #Orange
                self.Color2 = O  #Orange
                self.TextColor = W  #White
                self.TextColor2 = B  #Black

            # Headliner - Black and Pink
            elif self.Val_Theme == "Headliner":
                self.BGColor = B #Black
                self.Color = PI  #Pink
                self.Color2 = KP  #Kinda Pink
                self.TextColor = W  #White
                self.TextColor2 = B  #Black

            # Mosh Pit - Black and Red
            elif self.Val_Theme == "Mosh Pit":
                self.BGColor = AB #Almost Black
                self.Color = BF  #Black Flag Red
                self.Color2 = BF #Black Flag Red
                self.TextColor = W #White
                self.TextColor2 = W #White

            else:
                print("Theme?")

        except:

            ErrorHandling.ShowError(self, "Epic Fail!", "There was an issue getting your options.")

    # Open Options.csv and get options
    def GetTapListOptions(self):

        try:

            # Open Options file and read row into a list
            with open(Path_TapListOptions) as csvfile:
                readCSV = csv.reader(csvfile, delimiter=',')
                readCSV = list(readCSV)  # Create list from file data
                rows = len(readCSV)  # Get number of items in list

                if rows == 0:  # If there is nothing in the list, this implies options have not been set
                    print("No options set for Tap List")
                else:  # If there are items in Tap List Options.csv, options have been set before
                    # Use dictionaries to look up column index of option
                    # readCSV[row index][column index]
                    self.Val_BeerFontSize = readCSV[0][Dict_TapListOptionsColumn['Beer Font Size']]
                    self.Val_StyleFontSize = readCSV[0][Dict_TapListOptionsColumn['Style Font Size']]
                    self.Val_SizePriceFontSize = readCSV[0][Dict_TapListOptionsColumn['SizePrice Font Size']]
                    self.Val_PadX = readCSV[0][Dict_TapListOptionsColumn['PadX']]
                    self.Val_PadY = readCSV[0][Dict_TapListOptionsColumn['PadY']]
                    self.Val_Name = readCSV[0][Dict_TapListOptionsColumn['Name']]
                    self.Val_ListName = readCSV[0][Dict_TapListOptionsColumn['List Name']]
                    self.Val_TopTitle = readCSV[0][Dict_TapListOptionsColumn['Top Title']]
                    self.Val_Columns = readCSV[0][Dict_TapListOptionsColumn['Columns']]
                    self.Val_BackgroundColor = readCSV[0][Dict_TapListOptionsColumn['Background Color']]
                    self.Val_TopBackgroundColor = readCSV[0][Dict_TapListOptionsColumn['Top Background Color']]
                    self.Val_NameTextColor = readCSV[0][Dict_TapListOptionsColumn['Name Text Color']]
                    self.Val_ListNameTextColor = readCSV[0][Dict_TapListOptionsColumn['List Name Text Color']]
                    self.Val_BeerBackgroundColor = readCSV[0][Dict_TapListOptionsColumn['Beer Background Color']]
                    self.Val_BeerTextColor = readCSV[0][Dict_TapListOptionsColumn['Beer Text Color']]
                    self.Val_StyleBackgroundColor = readCSV[0][Dict_TapListOptionsColumn['Style Background Color']]
                    self.Val_StyleTextColor = readCSV[0][Dict_TapListOptionsColumn['Style Text Color']]
                    self.Val_SizePriceBackgroundColor = readCSV[0][Dict_TapListOptionsColumn['SizePrice Background Color']]
                    self.Val_SizePriceTextColor = readCSV[0][Dict_TapListOptionsColumn['SizePrice Text Color']]
                    self.Val_NameFontSize = readCSV[0][Dict_TapListOptionsColumn['Name Font Size']]
                    self.Val_ListNameFontSize = readCSV[0][Dict_TapListOptionsColumn['List Name Font Size']]
                    self.Val_DisplayStyle = readCSV[0][Dict_TapListOptionsColumn['Display Style']]
                    self.Val_DisplayABV = readCSV[0][Dict_TapListOptionsColumn['Display ABV']]
                    self.Val_DisplayDescription = readCSV[0][Dict_TapListOptionsColumn['Display Description']]
                    self.Val_DisplayWrap = readCSV[0][Dict_TapListOptionsColumn['Display Wrap']]
                    self.Val_DescriptionFontSize = readCSV[0][Dict_TapListOptionsColumn['Description Font Size']]
                    self.Val_DescriptionBackgroundColor = readCSV[0][Dict_TapListOptionsColumn['Description Background Color']]
                    self.Val_DescriptionTextColor = readCSV[0][Dict_TapListOptionsColumn['Description Text Color']]
                    self.Val_DisplayPricing = readCSV[0][Dict_TapListOptionsColumn['Display Pricing']]
                    self.Val_PresetTheme = readCSV[0][Dict_TapListOptionsColumn['Preset Theme']]

        except:

            ErrorHandling.ShowError(self, "Epic Fail!", "There was an issue getting your options.")

    # Preset Theme
    def PresetTheme(self, Theme):

        try:

            if Theme == "The Matrix":
                self.Combo_BackgroundBG.set('Black')
                self.Combo_TopBG.set('Black')
                self.Combo_NameText.set('Green - UFO')
                self.Combo_ListNameText.set('Green - UFO')
                self.Combo_BeerBG.set('Green - UFO')
                self.Combo_BeerText.set('Black')
                self.Combo_StyleBG.set('Black')
                self.Combo_StyleText.set('Green - UFO')
                self.Combo_SizePriceBG.set('Black')
                self.Combo_SizePriceText.set('Green - UFO')
                self.Combo_DescriptionBG.set('Black')
                self.Combo_DescriptionText.set('Green - UFO')

            elif Theme == "Spy vs. Spy":
                self.Combo_BackgroundBG.set('White')
                self.Combo_TopBG.set('White')
                self.Combo_NameText.set('Black')
                self.Combo_ListNameText.set('Black')
                self.Combo_BeerBG.set('Black')
                self.Combo_BeerText.set('White')
                self.Combo_StyleBG.set('White')
                self.Combo_StyleText.set('Black')
                self.Combo_SizePriceBG.set('White')
                self.Combo_SizePriceText.set('Black')
                self.Combo_DescriptionBG.set('White')
                self.Combo_DescriptionText.set('Black')

            elif Theme == "Blackout":
                self.Combo_BackgroundBG.set('Black')
                self.Combo_TopBG.set('Black')
                self.Combo_NameText.set('White')
                self.Combo_ListNameText.set('White')
                self.Combo_BeerBG.set('Grey - Gun Metal')
                self.Combo_BeerText.set('White')
                self.Combo_StyleBG.set('Black')
                self.Combo_StyleText.set('White')
                self.Combo_SizePriceBG.set('Black')
                self.Combo_SizePriceText.set('White')
                self.Combo_DescriptionBG.set('Black')
                self.Combo_DescriptionText.set('White')

            elif Theme == "Mardi Gras":
                self.Combo_BackgroundBG.set('Purple - Twilight')
                self.Combo_TopBG.set('Purple - Twilight')
                self.Combo_NameText.set('Yellow - Sunflower')
                self.Combo_ListNameText.set('Yellow - Sunflower')
                self.Combo_BeerBG.set('Green - Palm')
                self.Combo_BeerText.set('White')
                self.Combo_StyleBG.set('Yellow - Sunflower')
                self.Combo_StyleText.set('Black')
                self.Combo_SizePriceBG.set('Yellow - Sunflower')
                self.Combo_SizePriceText.set('Black')
                self.Combo_DescriptionBG.set('Yellow - Sunflower')
                self.Combo_DescriptionText.set('Black')

            elif Theme == "Mosh Pit":
                self.Combo_BackgroundBG.set('Black')
                self.Combo_TopBG.set('Black')
                self.Combo_NameText.set('Red - Mosh Pit')
                self.Combo_ListNameText.set('Red - Mosh Pit')
                self.Combo_BeerBG.set('Black')
                self.Combo_BeerText.set('White')
                self.Combo_StyleBG.set('Black')
                self.Combo_StyleText.set('Red - Mosh Pit')
                self.Combo_SizePriceBG.set('Black')
                self.Combo_SizePriceText.set('Red - Mosh Pit')
                self.Combo_DescriptionBG.set('Black')
                self.Combo_DescriptionText.set('Red - Mosh Pit')

            self.SaveTapListOptions()

        except:

            ErrorHandling.ShowError(self, "Epic Fail!", "There was an issue setting the preset theme.")

    #Check reset checkboxes for status (enable or disable RESET button)
    def CheckReset(self):

        try:

            Defcon2 = self.Var_Defcon2.get() #get value of DEFCON 2 checkbox
            Defcon1 = self.Var_Defcon1.get() #get value of DEFCON 1 checkbox

            if Defcon2 == "1" and Defcon1 == "1": #If both checkboxes are checked
                self.Btn_Reset.config(state = tk.NORMAL) #Enable RESET button
            else: #If one or both are not checked
                self.Btn_Reset.config(state=tk.DISABLED) #Disable RESET button

        except:

            ErrorHandling.ShowError(self, "Epic Fail!", "There was an issue checking the reset buttons.")

    #Reset (Clears all data files in the Inventory directory, custom styles, and saves to  history file)
    def Reset(self):

        try:

            #Clear Inventory Files
            for File in List_InventoryDirFiles: #Loop through files in Inventory directory (data files)
                Path_File = path.join("Inventory", File) #Get path to file
                f = open(Path_File, "w+") #Open and clear
                f.close() #Close file

            #Clear Custom Styles file
            f = open(Path_CustomStyles, "w+")  # Open and clear
            f.close()  # Close file

            #Add "ADD STYLE" back to Custom Styles file
            with open(Path_CustomStyles, mode='a', newline='') as CustomStyles_file:  # opens file with 'a' for append, does not overwrite anything already in it
                CustomStyles_writer = csv.writer(CustomStyles_file, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
                CustomStyles_writer.writerow(["ADD STYLE"])

            #Record reset to History file
            RecordReset = "-------------------------------- RESET (" + str(self.Date) + ") --------------------------------"
            with open('History.csv', mode='a', newline='') as History_file:  # opens file with 'a' for append, does not overwrite anything already in it
                History_writer = csv.writer(History_file, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
                History_writer.writerow([RecordReset])

            self.Var_Defcon2.set(value = 0) #Uncheck DEFCON 2 checkbox
            self.Var_Defcon1.set(value = 0) #Uncheck DEFCON 1 checkbox

            ErrorHandling.ShowInfo(self, "Rock On!", "Keg Punk has been reset.")

        except:

            ErrorHandling.ShowError(self, "Epic Fail!", "There was an issue reseting Keg Punk.")

    #User clicks "Check For Updates" button, gives a pop-up with info on updates
    def CheckForUpdates(self):

        try:
            url_Downloads = 'https://www.arithmech.com/downloads'
            html = urlopen(url_Downloads)

            try:
                reqs = requests.get(url_Downloads)  # Get into page
                soup = BeautifulSoup(reqs.text, 'html.parser')  # Get everything

                urls = []  # Create empty list to hold urls
                for link in soup.find_all('a'):  # Look through everything
                    urls.append(link.get('href'))  # Get links

                for url in urls:  # Loop through urls in list
                    if 'LatestVersion.csv' in url:  # If the url contains string 'LatestVersion.csv'
                        url_LatestVersionFile = url  # save url
                    else:
                        pass

                file = urllib.request.urlopen(url_LatestVersionFile)  # open file

                for line in file:  # Loop through lines of file
                    LatestVersion = line.decode("utf-8")  # Get text from line

                LatestVersion = LatestVersion.split(',')
                LatestVersion = LatestVersion[1]

            except:

                LatestVersion = "Not Available"

        except:

            LatestVersion = "Not Available"

        # Get Current Version. Try to open the Version.csv file.
        try:

            with open('Version.csv') as csvfile:  # if version file exists, get details from it
                readCSV = csv.reader(csvfile, delimiter=',')
                readCSV = list(readCSV)  # Create list from file data

                self.Version = readCSV[0][Dict_VersionHeaders['Version']]
                self.CurrentVersion = self.Version

        except:  # If Version.csv file does not exist

            self.CurrentVersion = '1.0'

        # Keg Punk up to date
        if self.CurrentVersion == LatestVersion:  # if the current version is equal to latest version
            ErrorHandling.ShowInfo(self, 'Up to Date', 'Keg Punk is up to date.\n\nCurrent Version: ' + str(self.CurrentVersion) + '\nLatest Version: ' + str(LatestVersion))

        # Keg Punk update available
        else:  # If the current version is different than the latest version, prompt user to update
            ErrorHandling.ShowInfo(self, 'Update Available', 'There is an update available for Keg Punk!\n\nCurrent Version: ' +
                                    str(self.CurrentVersion) + '\nLatest Version: ' + str(LatestVersion) + '\n\nQuit Keg Punk and restart. Click "Yes" when prompted.')

    #Go to Keg Punk directory
    def ViewFiles(self):

        try:

            filename = filedialog.askopenfilename(initialdir=self.Dir_Parent, title="Keg Punk Files", filetypes=(("all files","*.*"),("Text files","*.txt*")))

        except:

            ErrorHandling.ShowError(self, "Epic Fail!", "There was an issue navigating to the files.")

    #Configure the width of combobox drop down menu to fit longest value
    def on_combo_configure(self, widget):

        style = ttk.Style()
        current_combo_style = widget.cget('style') or "TCombobox" # check if the combobox already has the "postoffest" property

        if len(style.lookup(current_combo_style, 'postoffset')) > 0:
            return

        combo_values = widget.cget('values')
        longest_value = max(combo_values, key=len)

        font = tkfont.nametofont(str(widget.cget('font')))

        width = font.measure(longest_value + "0") # - widget.width

        unique_name = 'Combobox{}'.format(widget.winfo_id()) # create a unique style name using widget's id

        if unique_name in current_combo_style: # the new style must inherit from current widget style (unless it's our custom style!)
            style_name = current_combo_style
        else:
            style_name = "{}.{}".format(unique_name, current_combo_style)

        style.configure(style_name, postoffset=(0, 0, width, 0))
        widget.configure(style=style_name)

    # Check if there are any toplevels already open, close if they are (exception - Tap List)
    def CloseToplevels(self):

        for wid in root.winfo_children():  # Loop through all of widgets in root window
            WidClass = wid.winfo_class()  # Get the class of each widget
            if WidClass == "Toplevel":  # If the widget is a "Toplevel" window
                if wid.winfo_name() == 'taplist':
                    pass
                else:
                    wid.destroy()  # Close it

    #Destroy root window and record Quit
    def QuitKegPunk(self, Frame):

        try:

            # Get todays date
            try:
                self.Date = date.today()
            except:  # If unable to get date (not connected to Wifi) set as Date Unknown
                self.Date = "Date Unknown"
            QuitMessage = "--------------------------------- QUIT (" + str(self.Date) + ") --------------------------------"
            self.Record(QuitMessage)

            Frame.destroy()

        except:

            ErrorHandling.ShowError(self, "Epic Fail!", "There was an issue quiting Keg Punk.")


#Object (class) codes
m = MainApplication
ts = TapStatus
tm = TaproomManager
cm = CellarManager
tl = TapList
r = Reports

#Program loop
if __name__ == "__main__":
    root = tk.Tk()
    #MainApplication(root).pack(side="top", fill="both", expand=True)
    MainApplication(root).grid(row=0, column=0, sticky=tk.NSEW)
    root.mainloop()
